/* ahnenpt.ll {{{1
         
* @progname	ahnenpt
* @version 	5.5.0 (02.02.2010)
* @author 	Patrick Texier (p.texier@genindre.org)
* @category
* @output 	Text/HTML/LaTex
* @description

Liste d'ascendance avec les titres, professions mariages.
Cette édition est adaptée de ahnentafel de Tom Wetmore, bien
qu'il ne reste presque plus rien de l'original.

Patrick Texier 21 DEC 2001		

French translation
   
Using CHR, BURI, MARC
HTML Output

09.02.2002 : Correction espaces avant les professions en texte

19.08.2002 : Ajout des contrats de mariage (1.20).

13.03.2003 : Prénom usuel en italique (1.30).
   				Date des professions
				Edition des titres.
03.07.2004 : Suppression des doubles espaces dans les dates	

19.01.2005 : On supprime les liens parents si on a un implexe
             et que l'on ne les développe pas, ils pointaient
			 sur rien.
18.09.2007 : (2.99.02)
			- Passage en UTF-8 avec utilisation de la croix u2020 à la place du + pour les
			décès.
			- Suppression des virgules dans les titres pour le format GeneWeb.
			- Possibilité de féminiser les titres.
			- Déclaration explicite de toutes les variables.

27.10.2007 (4.3)
			- Gestion des noms associés aux titres dans GeneWeb
21.07.2008 (4.4)
			- Modification pour ne plus éditer plusieurs fois le même arbre
12.08.2008 (4.4.1)
			- Lecture du nom associé au titre style GeneWeb avec un tag _NAME
			  pour ne pas polluer les notes.
05.10.2008 (4.4.2)
			- Lecture de NPFX pour indiquer des titres comme prince N. en
			  dehors des chefs de famille.
22.12.2008 (4.4.3)
			- Affichage des notes.
13.04.2009 (5.0)
			- Affichage des mariages au niveau de l'époux et plus de l'épouse
			- On n'affiche le mariage si on a seulement l'année et un contrat
			de mariage.
			- Passage des numéros sosas en float pour éviter le débordement quand
			on remonte à Charlemagne.
23.04.2009 (5.0.2)
			- Gestion des filles-mères pour le compte des générations en
			  de Moura : on remonte par la mère si le père n'a pas de nom et
			  si la mère a le même nom que l'enfant.
			- Calcul des distances avec le lieu de naissance du de-cujus
26.04.2009 (5.0.3)
			- Affichage du prénom usuel texte entre ""
01.06.2009 (5.0.4)
			- Affichage du lieu des professions.
19.10.2009 (5.1.0)
			- Affichage des cousinages avec une personne
02.11.2009 (5.1.1)
			- Possibilité de sélectionner le lieu d'origine pour le calcul des
			distance.
03.11.2009 (5.3.0)
			- Possibilité d'éditer les événements BMS multiples.
28.01.2010 (5.4.0)
			- Affichage des notaires des cm et des employeurs (AGNC)
02.02.2010 (5.5.0)
			- Les mariages sont date ni lieux ne sont plus affichés : on affiche le
			libellé "non mariés".
			- Édition de l'employeur avant la ville pour la commune.
}}}1 */
char_encoding("UTF-8") 
/* option("explicitvars") */
include("ptfunct.li")
include("ptinit.li")
include("ptplac1.li")
include("ptplac2.li")
/* Déclaration des variables {{{1 */
global(versll)		/* Version */
global(indiv)		/* Indi working */
global(indis)		/* Indi spouse */
global(indip)		/* Last indi */
global(isex)		/* Indi sex */
global(fami)
global(demoura)		/* édition de Moura */
global(affgen1)		/* affichage sommet de Moura ? (O/N) */
global(ahnen)
global(lastahnen)
global(dist)
global(n)
global(nboccu)
global(occu)
global(nbtitl)
global(titl)
global(nom2)
global(mynode)
global(mynode2)
global(nodemarc)
global(myoccu)
global(valagnc)		/* valeur de AGNC : notaire, employeur... */
global(evt_mult)	/* Affichage des événements multiples ? */
global(affcles)		/* Affichage des clés ? O/N */
global(affnotes)	/* Affichage des notes ? O/N */
global(nln) 		/* New line */
global(output_type)	/* 0-Text 1-Html 2-PdfLaTeX*/
global(links)		/* 1 Using <a name> */
global(bold)		/* bold */
global(fbold)		/* end bold */
global(ital)		/* italic */
global(fital)		/* end italic */
global(usuel)		/* enrichissement prénom usuel */
global(fusuel)		/* fin enrichissement prénom usuel */
global(titre)		/* <h4> */
global(ftitre)		/* </h4> */
global(accol)		/* Accolades pour LaTeX */
global(faccol)		/* Accolades pour LaTeX */
global(TEXT)		/* 0 */
global(HTML)		/* 1 */
global(work)
global(libchil)
global(libfath)
global(libmoth)
global(libbirt)
global(libbirt2)
global(libbapt)
global(libbapt2)
global(libdeat)
global(libdeat2)
global(libburi)
global(libburi2)
global(libmarr)
global(libnomarr)
global(libmarc)

global(racine)
global(mynode)
global(mynode2)
global(usuel)
global(ws)
global(listname)
global(elem)
global(bidon)
global(partie)
global(jj)
global(mm)
global(aa)
global(dd)
global(implexe)
global(before)
global(calrep)
global(maxgen)
global(affcoord) /* affichage des coordonées O/N */
global(lieu_orig) /* lieu d'origine pour distance sinon naissance du de-cujus */
global(listelieu) /* pour enlever le lieu-dit */
global(decoupage) /* redécoupage du lieu */
global(decoupage_occu) /* redécoupage du lieu pour profession */
global(optdec)
global(indis)
global(indip)
global(titresgw)
global(femin)
global(flagfem)
global(dectitre)
global(untitre)
global(nbr)
global(setcousin)
global(settrav)
global(cousin)

global(tagcert) /* Tag incertitude */
global(sosacert) /* Table des sosa incertains */
global(libcert) /* Libellé incertitude */
global(basesosa)
global(valcert)
global(clecert)

global(LATEX)
global(TEXT)
global(HTML)

global(MD_INDI)
global(MD_REC)
global(MD_GOTHA)
global(MD_JOANNIS)

global(lang)
global(manquants)
global(proccu)
global(menumode)
global(even)
global(mode)
global(llexec)	/* Mode llexec sans sélections */
global(recdate)
global(recindi)
global(liste)
global(arbrestable) /* Table des arbres déjà édités */
global(latdc) 		/* Lattitude naissance de-cujus */
global(londc)		/* Longutude naissance de-cujus */

global(lastgen)	/* Dernière génération éditée */
global(gennum)	/* Table pour découpage de Moura génération/numéro */

global(clist)
global(glist)
global(tfam)
global(tindi)
global(tnum)
global(tenf)
global(prepdm)
global(settr)
global(setanc)
global(tgen)
global(yearonly)
/* }}}1 */
proc main () /* {{{1 */
{
	set(llexec, 0)
	call init()
	if(llexec) {
		call selection_auto()
	}
	else {
		call selection()
	}
	if(yearonly) {
		set(affcles, 0)
		set(affnotes, 0)
		set(affcoord, 0)
		set(proccu, 0)
		dayformat(2)
		monthformat(2)
		yearformat(2)
		eraformat(0) /* TODO */
		dateformat(3)
		complexpic(0, "~%1")
		complexpic(1, "~%1")
		complexpic(2, "~%1")
		complexpic(3, "<%1")
		complexpic(4, ">%1")
		complexpic(5, "%1/%2")
	}
	if(or(not(implexe), not(basesosa))) {
		set(manquants, 0)
	}
	call init2()
	if(affcoord) {
		call load_coord1()
		if(eq(affcoord, 2)) {
			call load_coord2()
			call coord_orig(indiv, lieu_orig)
		}
	}
	if(eq(mode, MD_INDI)) {
		if(demoura) {
			call onedemoura(indiv, 0)
		}
		else {
			call oneahnen(indiv, 0)
		}
	}
	elsif(eq(mode, MD_REC)) {
		call recahnen(even)
	}
	elsif(eq(mode, MD_GOTHA)) {
		call gothaahnen(even)
	}
	elsif(eq(mode, MD_JOANNIS)) {
		call joannisahnen(even)
	}
	else {
		print("Mode non trouvé\n")
		return()
	}
	/* footer HTML */
	if(eq(output_type, HTML)) {
		/*
		"<hr>\n<address>Page générée par <a href=" qt() "http://www.genindre.org/ftp/lifelines/" qt() ">"
		"ahnenpt.ll</a> " versll
		", un rapport <a href=" qt() "http://lifelines.sourceforge.net" qt() ">"
		"LifeLines</a>.</address>\n</body>\n</html>\n"
		*/
		"<hr>\n<address>Page générée par ahnenpt.ll " versll
		", un rapport <a href=" qt() "http://lifelines.sourceforge.net" qt() ">"
		"LifeLines</a>.</address>\n</body>\n</html>\n"
	}
	elsif(eq(output_type, LATEX)) {
		"\\end{document}\n"
	}
	else {
		/* TODO : à paramétrer */
		"\n\n------------------------------------------------------------------------------\n"
		"Fichier généré par ahnenpt.ll v" versll "\n"
		"un rapport LifeLines <http://lifelines.sourceforge.net>\n\n"
		"Patrick Texier <p.texier@orsennes.com>, le "
		dayofweek(gettoday()) " " nettoie(stddate(gettoday())) "\n"
		"------------------------------------------------------------------------------\n"
	}
}
/* }}}1 */
proc init() /* {{{1 */
{
	call pt_init()
	set(poslieudit, pt_pos_lieudit)
	set(versll, "5.5.0")

	set(TEXT, 0)
	set(HTML, 1)
	set(LATEX, 2)
	/* modes : 1 = une personne, >1 les personnes d'un enregistrement EVEN */
	set(MD_INDI, 1)
	set(MD_REC, 2)
	set(MD_GOTHA, 3)
	set(MD_JOANNIS, 4)

	list(menumode)
	setel(menumode, MD_INDI, "Une personne")
	setel(menumode, MD_REC, "Une liste de type recensement")
	setel(menumode, MD_GOTHA, "Une liste de type Gotha")
	setel(menumode, MD_JOANNIS, "Une liste de type Joannis")

	dayformat(2)
	monthformat(8)
	dateformat(0)

	set(libbirt, "    °  ")
	set(libbapt, "    b  ")
	set(libdeat, "    †  ") /* TODO Mort au combat u2694 ? */
	set(libburi, "   (†) ")
	set(libbirt2, " [  °  ")
	set(libbapt2, " [  b  ")
	set(libdeat2, " [  †  ") /* TODO Mort au combat u2694 ? */
	set(libburi2, " [ (†) ")
	set(libmarr, "    ×  ")
	set(libmarc, "    cm ")
	set(libnomarr, "    non mariés")
	set(libchil, "enfant")
	set(libfath, "père")
	set(libmoth, "mère")

	list(listelieu)
} /* }}}1 */
proc init2() /* {{{1 */
{
	indiset(setcousin)
	indiset(settrav)
	addtoset(settrav, cousin, 1)
	set(setcousin, ancestorset(settrav))
	if (eq(output_type, HTML)) {
		set(nln, "<br>\n")
		set(bold, "<b>")
		set(fbold, "</b>")
		set(ital, "<i>")
		set(fital, "</i>")
		set(titre, "<h4>")
		set(ftitre, "</h4>")
		set(usuel, ital)
		set(fusuel, fital)
		"<!DOCTYPE HTML PUBLIC " qt() "-//W3C//DTD HTML 4.01 Transitional//EN" qt() ">\n"
		"<html>\n<head>\n"
		"<meta http-equiv=" qt() "Content-Type" qt() " content=" qt() "text/html; charset=utf-8" qt() ">\n"
		"<title>Les ancêtres de " givens(indiv) " " surname(indiv) "</title>\n"
		"</head>\n<body>\n"
	}
	elsif (eq(output_type, LATEX)) {
		set(nln, "\\\\\n")
		set(bold, "\\textsc{")
		set(fbold, "}")
		set(ital, "{\\em ")
		set(fital, "}")
		set(titre, "")
		set(ftitre, "")
		set(usuel, ital)
		set(fusuel, fital)
		set(accol, "{")
		set(faccol, "}")
		call entetelatex()
	}
	else {
		set(nln, "\n")
		set(bold, "")
		set(fbold, "")
		set(ital, "")
		set(fital, "")
		set(usuel, "\"")
		set(fusuel, usuel)
	}
	if(cousin) {
		"cous. = cousinage avec " givens(cousin) " " surname(cousin) nln nln
	}
}
/* }}}1 */
proc selection_auto() /* {{{1 */
{
	/* de Tornos 10 gen */
	/* set(indiv, indi("I70939")) */
	if(1) {
		newfile("trav.txt", 0)
	}
	/* MD_INDI */
	set(mode, MD_INDI)
	set(indiv, indi("I92563"))
	set(indiv, indi("I39975"))

	set(indiv, indi("I93114"))
	/* MD_JOANNIS */
	/* 
	set(mode, MD_JOANNIS)
	set(even, "E58")
	*/
	/* TODO : prévoir saisie */
	/* set(cousin, indi("I1")) */
	set(pt_pays_defaut, pt_pays_bel)

	set(basesosa, 1)

	set(affcles, 1)
	set(affnotes, 0)
	set(calrep, 1)
	set(implexe, 1)
	set(manquants, 1)
	set(evt_mult, 1)
	/* 0 = texte, 1 HTML, 2 LaTeX */
	set(output_type, 0)
	set(maxgen, 7)
	set(links, 1)
	/* 0 : non, 1 : oui, 2 : avec distances */
	set(affcoord, 2)
	set(lieu_orig, "Bruxelles, 21024,,, Belgique")


	set(decoupage, "132P45")
	set(decoupage_occu, "1N")
	set(optdec, "SIP")
	
	set(proccu, 1)
	set(titresgw, 1)
	set(femin, 0)
	set(tagcert, "_HYP")
	set(demoura, 0)
	set(affgen1, 1)

	set(yearonly, 0)
} 
/* }}}1 */
proc selection() /* {{{1 */
{
	if(1) {
		set(mode, menuchoose(menumode, "Sélectionnez le type d'édition :"))
	}
	else {
		set(mode, MD_INDI)
	}
	if(1) {
		if(eq(mode, MD_INDI)) {
			getindi(indiv, "Sélectionnez la personne :")
			if(not(indiv)) { return() }
		}
		else {
			getstr(even, "Clé de l'événement (EVEN) ?")
		}
	}
	else {
		if(eq(mode, MD_INDI)) {
			set(indiv, indi("I1"))
		}
		else {
			set(even, "E1")
		}
	}
	if(1) {
		if(eq(mode, MD_INDI)) {
			getint(demoura, "Type (0/Sosa 1/de Moura) :")
		}
		else {
			set(demoura, 0)
		}
	}
	if(1) {
		getint(affnotes, "Afficher les notes ? 0/Non, 1/Oui")
	}
	else {
		set(affnotes, 0)
	}
	if(1) {
		getint(affcles, "Afficher les clés ? 0/Non, 1/Oui")
	}
	else {
		set(affcles, 1)
	}
	/* pas encore programmé */
	if(1) {
		getint(evt_mult, "Afficher les événements multiples ? 0/Non, 1/Oui")
	}
	else {
		set(evt_mult, 1)
	}
	if(1) {
		getint(calrep, "Calculer les dates républicaines ? 0/Non, 1/Oui")
	}
	else {
		set(calrep, 1)
	}
	if(0) {
		getint(proccu, "Recherche professions et titres ? 0/Non, 1/Oui")
	}
	else {
		set(proccu, 1)
	}
	if(and(0, proccu)) {
		/* C'est pour les titres au format GeneWeb TITL titre, domaine */
		getint(titresgw, "Titres de noblesse GeneWeb (titre, domaine) ? 0/Non, 1/Oui")
	}
	else {
		set(titresgw, 1)
	}
	if(and(0, proccu, titresgw)) {
		getint(femin, "Féminiser les titres GeneWeb ? 0/Non, 1/Oui")
	}
	else {
		set(femin, 0)
	}
	if(not(demoura)) {
		if(1) {
			getint(implexe, "Continuer les branches implexées ? 0/Non, 1/Oui")
			/* On ne peut imprimer les quartiers manquants qu'en continuant
			   les branche implexées */
			if(and(1, implexe)) {
				getint(manquants, "Afficher les numéros Sosa manquants ? 0/Non, 1/Oui")
			}
			else {
				set(manquants, 1)
			}
		}
		else {
			set(implexe, 1)
			set(manquants, 1)
		}
	}
	if(1) {
		getint(output_type, "Quel type de sortie ? 0/Texte, 1/HTML, 2/LaTeX")
	}
	else {
		set(output_type, 1)
	}
	/* TODO : je suis pas que la limite a un sens en de Moura */
	if(not(demoura)) {
		if(1) {
			getint(maxgen, "Nombre de générations maximum (0=pas de limite) ?")
			if(eq(maxgen, 0)) { set(maxgen, 999) }
		}
	}
	else {
		set(maxgen, 999)
	}
	if(1) {
		getint(links, "Création de liens ? 0/Non, 1/Oui")
	}
	else {
		set(links, 1)
	}
	if(1) {
		getstr(decoupage, "Redécoupage des lieux")
		getstr(optdec, "Options de redécoupage")
		getstr(decoupage_occu, "Redécoupage des lieux des professions")
	}
	else {
		set(decoupage, "")
		set(optdec, "")
		set(decoupage_occu, "")
	}
	if(1) {
		getint(affcoord, "Affichage des coord. géo. ? 0/Non, 1/Oui 2/Dist")
	}
	else {
		set(affcoord, 0)
	}
	/* TODO : les numéros ne correspondent plus aux générations mais
	 il manque la fonction log dans LifeLines */
	if(not(demoura)) {
		if(0) {
			getint(basesosa, "Numéro sosa initial (défaut=1) ?")
		}
		else {
			set(basesosa, 1)
		}
	}
	if(0) {
		getstr(tagcert, "Tag gedcom incertitude filiation ?")
	}
	else {
		set(tagcert, "_HYP")
	}
}
/* }}}1 */
/* recahnen : recensement {{{1 */
proc recahnen(even)
{
	list(liste)
	table(arbrestable)
	foreven(myeven, cpt) {
		if(eqstr(key(myeven), even)) {
			set(recdate, year(date(myeven)))
			"RECENSEMENT DE " recdate nln nln
			set(recdate, atoi(recdate))
			set(recarbre, 0)
			traverse(myeven, mynode, niveau) {
				if(eqstr(tag(mynode), "ADDR")) {
					nln "LIEU : " value(mynode) nln
				}
				elsif(eqstr(tag(mynode), "_FOY")) {
					nln "Foyer : " value(mynode) nln nln
				}
				elsif(eqstr(tag(mynode), "NOTE")) {
					"  " value(mynode) nln
				}
				elsif(eqstr(tag(mynode), "_HAB")) {
					set(recindi, indi(value(mynode)))
					"  " givens(recindi) " "
					surname(recindi)
					affage(recindi) " [" key(recindi) "]" /* TODO */
					push(liste, recindi)
					incr(recarbre)
					print ", arbre " d(recarbre)
					nln
				}
			}
			nln nln
			forlist(liste, valeur, bidon) {
				"ARBRE " d(bidon) nln nln
				set(par, parents(valeur))
				if(par) {
					set(clearbre, lookup(arbrestable, key(par)))
					if(clearbre) {
						call oneahnen(valeur, 1)
						"cf arbre " d(clearbre) nln nln
					}
					else {
						insert(arbrestable, key(par), bidon)
						call oneahnen(valeur, 0)
					}
				}
				else {
					call oneahnen(valeur, 0)
				}
			}
		}
	}
}

func affage(perso) { /* {{{1 */
	if(naiss, atoi(year(birth(perso)))) {
		set(age, sub(recdate, naiss))
	}
	elsif(naiss, atoi(year(baptism(perso)))) {
		set(age, sub(recdate, naiss))
	}
	else {
		return()
	}
	set(retour, concat(", ", d(age), " an"))
	if(gt(age, 1)) {
		set(retour, concat(retour, "s"))
	}
	return(retour)
}

/* gothaanhen : édition gotha {{{1 */
proc gothaahnen(even)
{
	set(chapitre, 0)
	/* TODO : à paramétrer */
	"                    LES SOIXANTE-QUATRE QUARTIERS\n"
	"                      DES CHEFS DE FAMILLE DE LA\n"
	"                       PREMIÈRE PARTIE DU GOTHA\n\n\n"

	foreven(myeven, cpt) {
		if(eqstr(key(myeven), even)) {
			traverse(myeven, mynode, niveau) {
				if(eqstr(tag(mynode), "PLAC")) {
					incr(chapitre)
					"CHAPÎTRE " upper(roman(chapitre)) " : " upper(value(mynode)) nln nln
				}
				elsif(eqstr(tag(mynode), "TITL")) {
					value(mynode)
				}
				elsif(eqstr(tag(mynode), "DATE")) {
					" " complexdate(value(mynode))
				}
				elsif(eqstr(tag(mynode), "INDI")) {
					nln nln
					call oneahnen(indi(value(mynode)), 0)
				}
			}
		}
	}
}
/* joannisanhen : édition de Joannis {{{1 */
proc joannisahnen(even)
{
	/* TODO C'est pour le moment en dur */

	"                  LES SEIZE QUARTIERS GÉNÉALOGIQUES" nln
	"                            DES CAPÉTIENS" nln
	"Édition actualisée des deux premiers tomes de l'ouvrage du comte Jean-Dominique" nln
	"de Joannis parus en 1958 et 1961 sous forme de listes d'ascendance. Les tableaux" nln
	"ajoutés reprennent le numéro de la planche de l'ancêtre capétien dont ils sont" nln
	"issus suivi de -B et d'un compteur (ex : 291-B1)." nln nln
	"La saisie est loin d'être achevée." nln

	table(arbrestable)
	foreven(myeven, cpt) {
		if(eqstr(key(myeven), even)) {
			traverse(myeven, mynode, niveau) {
				if(eqstr(tag(mynode), "_CHA")) {
					"CHAPÎTRE " value(mynode) " : "
				}
				elsif(eqstr(tag(mynode), "TITL")) {
					upper(value(mynode))
					nln nln
				}
				elsif(eqstr(tag(mynode), "_TAB")) {
					set(tableau, value(mynode))
					if(eq(substring(tableau, 1, 2), "cf")) {
						set(noprint, 1)
					}
					else {
						set(noprint, 0)
					}
				}
				elsif(eqstr(tag(mynode), "INDI")) {
					set(decujus, indi(value(mynode)))
					if(noprint) {
						"Planche " tableau
						nln nln
						call oneahnen(decujus, 1)
					}
					else {
						"PLANCHE " tableau " - " 
						givens(decujus) " " surname(decujus)
						nln nln

						set(par, parents(decujus))
						if(par) {
							set(clearbre, lookup(arbrestable, key(par)))
							if(clearbre) {
								call oneahnen(decujus, 1)
								"cf planche " clearbre nln nln
							}
							else {
								insert(arbrestable, key(par), tableau)
								call oneahnen(decujus, 0)
							}
						}
						else {
							call oneahnen(decujus, 0)
						}
					}
				}
			}
		}
	}
}
/* }}}1 */
proc onedemoura(param, gene) /* {{{1 */
{
	set(perso, param)
	"Les ancêtres de " givens(perso) " " surname(perso)
	nln nln
	"La notation n'est pas la trop habituelle Sosa-Stradonitz" nln
	"mais un compteur par génération" nln
	"Cette notation est utilisée par André de Moura dans son" nln
	"livre sur les ancêtres du Comte de Paris" nln nln
	list(clist)
	list(glist)
	list(prepdm)
	table(tfam)
	table(tindi)
	table(tnum)
	indiset(settr)
	indiset(setanc)
	table(tgen)
	/* Constitution de l'ensemble des ancêtres */
	addtoset(settr, indiv, 1)
	set(setanc, ancestorset(settr))
	addtoset(setanc, indiv, 1)
	call chargegen()
	insert(tindi, key(perso), "1-1")
	call affcoupledm(0, perso)
	enqueue(clist, parents(perso))
	enqueue(glist, 2)
	insert(tfam, key(parents(perso)), "2-1")
	insert(tindi, key(father(perso)), "2-1")
	insert(tindi, key(mother(perso)), "2-2")
	insert(tnum, "2", 2)
	set(gen, 1)
	while(couple, dequeue(clist)) {
		set(gen, dequeue(glist))
		if(par, parents(husband(couple))) {
			set(val, lookup(tfam, key(par)))
			if(not(val)) {
				if(cle, lookup(tnum, d(add(gen, 1)))) {
					insert(tnum, d(add(gen, 1)),add(cle, 2))
				}
				else {
					insert(tnum, d(add(gen, 1)),add(cle, 2))
				}
				enqueue(clist, par)
				enqueue(glist, add(gen, 1))
				insert(tfam, key(par), concat(d(add(gen, 1)), "-", d(add(cle, 1))))
				if(indiv, lookup(tindi, key(husband(par)))) {
					insert(tindi, key(husband(par)), concat(indiv, ",", d(add(gen, 1)), "-", d(add(cle, 1))))
				}
				else {
					insert(tindi, key(husband(par)), concat(d(add(gen, 1)), "-", d(add(cle, 1))))
				}
				if(indiv, lookup(tindi, key(wife(par)))) {
					insert(tindi, key(wife(par)), concat(indiv, ",", d(add(gen, 1)), "-", d(add(cle, 2))))
				}
				else {
					insert(tindi, key(wife(par)), concat(d(add(gen, 1)), "-", d(add(cle, 2))))
				}
			}
		}
		if(par, parents(wife(couple))) {
			set(val, lookup(tfam, key(par)))
			if(not(val)) {
				if(cle, lookup(tnum, d(add(gen, 1)))) {
					insert(tnum, d(add(gen, 1)), add(cle, 2))
				}
				else {
					insert(tnum, d(add(gen, 1)), add(cle, 2))
				}
				enqueue(clist, par)
				enqueue(glist, add(gen, 1))
				insert(tfam, key(par), concat(d(add(gen, 1)), "-", d(add(cle, 1))))
				if(indiv, lookup(tindi, key(husband(par)))) {
					insert(tindi, key(husband(par)), concat(indiv, ",", d(add(gen, 1)), "-", d(add(cle, 1))))
				}
				else {
					insert(tindi, key(husband(par)), concat(d(add(gen, 1)), "-", d(add(cle, 1))))
				}
				if(indiv, lookup(tindi, key(wife(par)))) {
					insert(tindi, key(wife(par)), concat(indiv, ",", d(add(gen, 1)), "-", d(add(cle, 2))))
				}
				else {
					insert(tindi, key(wife(par)), concat(d(add(gen, 1)), "-", d(add(cle, 2))))
				}
			}
		}
		/* On ne peut rien imprimer avant d'avoir fait un passage complet
		   sinon il manquerait des liens parents -> enfants */
		push(prepdm, couple)
	}
	set(lastgen, "0")
	forlist(prepdm, couple, bidon) {
		call affcoupledm(couple, 0)
	}
}
/* }}}1 */
proc chargegen() { /* {{{1 */
	/*
	   Tester les filles-mères :
	   - si pas de nom pour le père
	   - non de la mère identique à celui de l'enfant
	*/
	forindiset(setanc, indiv, bidon1, bidon2) {
		set(cptgen, 0)
		set(cont, 1)
		set(nindi, indiv)
		while(cont) {
			incr(cptgen)
			if(pere, father(nindi)) {
				if(eqstr(surname(pere), "____")) {
					set(mere, mother(nindi))
					if(eqstr(surname(mere), surname(nindi))) {
						set(nindi, mere)
					}
					else {
						set(nindi, pere)
					}
				}
				else {
					set(nindi, pere)
				}
			}
			else {
				set(cont, 0)
			}
		}
		insert(tgen, key(indiv), cptgen)
	}
}
/* }}}1 */
proc affcoupledm(couple, perso) { /* {{{1 */
	/* "------------------------------------------------------------------------" nln */
	"────────────────────────────────────────────────────────────────────────" nln
	/* affichage */ 
	list(decoup)

	if(couple) {
		set(famille, lookup(tfam, key(couple)))
		set(mari, husband(couple))
		set(femme, wife(couple))
	}
	else {
		set(famille, "1-1")
		set(mari, perso)
	}
	list(gennum)
	extracttokens(famille, gennum, bidon, "-")
	if(nestr(getel(gennum, 1), lastgen)) {
		set(lastgen, getel(gennum, 1))
		"Génération " lastgen nln
		/* "------------------------------------------------------------------------" nln */
		"────────────────────────────────────────────────────────────────────────" nln
	}
	if(links) {
		if(eq(output_type, HTML)) {
			"<a name=" qt() famille qt() ">"
		}
		elsif(eq(output_type, LATEX)) {
			"\\hypertarget{" famille "}"
		}
	}
	famille " "
	call printnom(mari)
	if(affcles) {
		" [" key(mari) "]"
		if(cousin) {
			if(inset(setcousin, mari)) {
				" cous."
			}
		}
	}
	nln
	if(proccu) {
		call getoccu(mari)
	}
	set(st, lookup(tindi, key(mari)))
	if(index(st, ",", 1)) {
		nln "    = " st nln
	}
	nln
	set(gen, lookup(tgen, key(mari)))
	set(couple2, parents(mari))
	/* TODO : ce devrait être inutile */
	if(eqstr(famille, "1-1")) {
		"    " d(gen) "e génération, parents : " addlinksdemoura("2-1") 
		nln nln
	}
	elsif(couple2) {
		set(cle, lookup(tfam, key(couple2)))
		"    " d(gen) "e génération, parents : "
		/* Gestion tag incertitude */
		if(nestr(tagcert, "")) {
			call gestcertdemoura(mari)
		}
		addlinksdemoura(cle)
		nln nln
	}
	elsif(affgen1) {
		"    1ère génération, parents : ???"
		nln nln
	}
	call printbirth(mari)
	call printdeath(mari)
	if (couple) {
		nln
		call printmar(key(couple))
		nln
		extracttokens(famille, decoup, nbdec, "-")
		set(famille2, concat(getel(decoup, 1), "-", d(add(strtoint(getel(decoup, 2)), 1))))
		if(links) {
			if(eq(output_type, HTML)) {
				"<a name=" qt() famille2 qt() ">"
			}
			elsif(eq(output_type, LATEX)) {
				"\\hypertarget{" famille2 "}"
			}
		}
		famille2 " "
		call printnom(femme)
		if(affcles) {
			" [" key(femme) "]"
			if(cousin) {
				if(inset(setcousin, femme)) {
					" cous."
				}
			}
		}
		nln
		if(proccu) {
			call getoccu(femme)
		}
		set(st, lookup(tindi, key(femme)))
		if(index(st, ",", 1)) {
			nln "    = " st nln
		}
		nln
		set(gen, lookup(tgen, key(femme)))
		if(couple2, parents(femme)) {
			set(cle, lookup(tfam, key(couple2)))
			"    " d(gen) "e génération, parents : "
			/* Gestion tag incertitude */
			if(nestr(tagcert, "")) {
				call gestcertdemoura(femme)
			}
			addlinksdemoura(cle)
			nln nln
		}
		elsif(affgen1) {
			"    1ère génération, parents : ???"
			nln nln
		}
		call printbirth(femme)
		call printdeath(femme)
		nln
		call affenfants(couple)
	}
}
/* }}}1 */
proc affenfants(couple) { /* {{{1 */
	set(st, "")
	set(cpt, 0)
	set(cpt2, 0)
	set(cpt3, 0)
	set(cpt4, 0)
	list(listtr)
	children(couple, enfant, bidon) {
		if(inset(setanc, enfant)) {
			incr(cpt)
			set(st2, lookup(tindi, key(enfant)))
			extracttokens(st2, listtr, cpt2, ",")
			set(st2, addlinksdemoura(pop(listtr)))
			if(eq(cpt2, 2)) {
				set(st3, pop(listtr))
				set(st2, concat(st2, " = ", addlinksdemoura(st3)))
			}
			elsif(ge(cpt2, 2)) {
				set(st3, pop(listtr))
				set(st2, concat(st2, " = (", addlinksdemoura(st3)))

				forlist(listtr, st3, bidon) {
						set(st2, concat(st2, ", ", addlinksdemoura(st3)))
				}
				set(st2, concat(st2, ")"))
			}
			if(eq(cpt, 1)) {
				set(st, st2)
			}
			else {
				set(st, concat(st, ", ", st2))
			}
		}
	}
	"    " d(cpt) " enfant"
	if(gt(cpt, 1)) {
		"s"
	}
	" : " st nln
}
/* */
proc oneahnen(param, gene) /* {{{1 */
{
	set(perso, param)
	if(not(gene)) {
		set(gene, maxgen)
	}
	/* En Joannis, la personne est récupérée dans EVEN */
	if(ne(mode, MD_JOANNIS)) {
		if(eq(output_type, HTML)) {
			"<h3>"
		}
		"Les ancêtres de " givens(perso) " " surname(perso)
		if(eq(output_type, HTML)) {
			"</h3>"
		}
		nln nln
	}
	set(indip, perso)
	list(ilist)
	list(alist)
	list(glist)
	table(other)
	table(ktab)
	table(sosacert)
	enqueue(ilist, perso)
	enqueue(alist, mul(basesosa, 1.0))
	enqueue(glist, 1)
	set(gen, 0)
	while(perso, dequeue(ilist)) {
		set(ahnen, dequeue(alist))
		set(newgen, dequeue(glist))
		/* Affichage des sosas manquants */
		if(manquants) {
			if(ne(ahnen, basesosa)) {
				set(dist, sub(sub(ahnen, 1), lastahnen))
				if(ge(dist, 0.5)) {
					if(eq(dist, 1)) {
						f(sub(ahnen, 1), 0) " Quartier inconnu"
					}
					else {
						f(add(lastahnen,1), 0) "-" f(sub(ahnen, 1), 0) " Quartiers inconnus"
					}
					nln
					if(not(yearonly)) {
						nln
					}
				}
			}
		}
		/* On n'affiche pas les générations s'il y en a qu'une */
		if (and(ne(gen, newgen), gt(gene, 1))) {
			if(yearonly) {
				nln
			}
			titre "Génération " upper(roman(newgen)) "." ftitre nln nln
		} /* Fin formatage */
		set(gen, newgen)
		set(isex, sex(perso))
		if(links) {
			if(eq(output_type, HTML)) {
				"<a name=" qt() f(ahnen, 0) qt() ">"
			}
			elsif(eq(output_type, LATEX)) {
				"\\hypertarget{" f(ahnen, 0) "}"
			}
		}
		/* Gestion tag incertitude */
		if(nestr(tagcert, "")) {
			call gestcert(perso)
		}
		set(before, lookup(ktab, key(perso)))
		if(before) {
			accol f(ahnen, 0) faccol ital " " libcert " = "
			if(links) {
				if(eq(output_type, HTML)) {
					"<a href=" qt() "#" f(before, 0) qt() ">" f(before, 0) "</a>"
				}
				elsif(eq(output_type, LATEX)) {
					"\\hyperlink{" f(before, 0) "}{" f(before, 0) "}"
				}
				else {
					f(before, 0)
				}
			}
			else {
				f(before, 0)
			}
			" (" call printnom(perso) ")"
			if(affcles) {
				" [" key(perso) "]"
				if(cousin) {
					if(inset(setcousin, perso)) {
						" cous."
					}
				}
			}
			if(links) {
				call addlinks(perso, ahnen)
			}
			fital
			if(not(yearonly)) {
				nln
			}
		} else {
			insert(ktab, key(perso), ahnen)
			f(ahnen, 0) " " libcert 
			call printnom(perso)
			if(affcles) {
				" [" key(perso) "]"
				if(cousin) {
					if(inset(setcousin, perso)) {
						" cous."
					}
				}
			}
			if(links) {
				call addlinks(perso, ahnen)
			}
			if(not(yearonly)) {
				nln
			}
			if(proccu) {
				call getoccu(perso)
			}
			if(yearonly) {
				call printshort(perso)
			}
			else {
				call printbirth(perso)
			}
			/* Print Marriage record */
			if(eqstr(isex, "M")) {
				if(couple, lookup(other, f(ahnen,0))) {
					/* TODO : l'afficher quand même */
					if(not(yearonly)) {
						call printmar(couple)
					}
				}
			}
			if(not(yearonly)) {
				call printdeath(perso)
			}
		}
		set(lastahnen, ahnen)
		set(indip, perso)
		nln
		/* On continue si pas impléxé ou paramêtre continuer l'implexe */
		if(or(implexe, not(before))) {
			set(nextgen, add(gen, 1))
			/* Test de la limite de générations */
			if(le(nextgen, gene)) {
				if(par, father(perso)) {
					enqueue(ilist, par)
					enqueue(alist, mul(2, ahnen))
					enqueue(glist, nextgen)
					/* Si on a un couple, on l'indique */
					if(oth, parents(perso)) {
						/*
						" parents " key(perso) " n " d(ahnen) " -> " key(oth) "\n"
						*/
						insert(other, f(mul(2, ahnen), 0), key(oth))
					}
				}
				if(par, mother(perso)) {
					enqueue(ilist, par)
					enqueue(alist, add(1, mul(2, ahnen)))
					enqueue(glist, nextgen)
				}
			}
		}
	}
}
/* }}}1 */
proc coord_orig(indiv, lieu) /* {{{1 */
{
	if(nestr(lieu, "")) {
		set(plac, lieu)
	}
	else {
		set(plac, place(birth(indiv)))
		if(eqstr(plac, "")) {
			set(plac, place(baptism(indiv)))
		}
	}
	set(coord, "")
	if(nestr(plac, "")) {
		set(coord, lookup(pt_coord1, plac))
		if(eqstr(coord, "")) {
			extracttokens(plac, listelieu, nbdecoup, ",")
			set(plac2, "")
			set(spc, "")
			set(i, 1)
			while(le(i, nbdecoup)) {
				if(ne(i, pt_pos_lieudit)) {
					set(ws, getel(listelieu, i))
				}
				else {
					set(ws, "")
				}
				if(and(nestr(plac2, ""), nestr(ws, ""))) {
					set(plac2, concat(plac2, " "))
				}
				set(plac2, concat(plac2, ws, ","))
				incr(i)
			}
			/* Suppression de la virgule finale */
			set(plac2, substring(plac2, 1, sub(strlen(plac2), 1)))
			set(coord, lookup(pt_coord1, plac2))
			if(not(eqstr(coord, ""))) {
				set(londc, lookup(pt_lon, plac2))
				set(latdc, lookup(pt_lat, plac2))
			}
			else {
				set(affcoord, 1)
			}
		}
		else {
			set(londc, lookup(pt_lon, plac))
			set(latdc, lookup(pt_lat, plac))
		}
	}
	else {
		set(affcoord, 1)
	}
}
func print_place(evt) /* {{{1 */
{
	set(plac, place(evt))
	set(coord, "")
	if(and(affcoord, nestr(plac, ""))) {
		set(coord, lookup(pt_coord1, plac))
		set(plat, lookup(pt_lat, plac))
		set(plon, lookup(pt_lon, plac))
		/* TODO */
		if(eqstr(coord, "")) {
			extracttokens(plac, listelieu, nbdecoup, ",")
			set(plac2, "")
			set(spc, "")
			set(i, 1)
			while(le(i, nbdecoup)) {
				if(ne(i, pt_pos_lieudit)) {
					set(ws, getel(listelieu, i))
				}
				else {
					set(ws, "")
				}
				if(and(nestr(plac2, ""), nestr(ws, ""))) {
					set(plac2, concat(plac2, " "))
				}
				set(plac2, concat(plac2, ws, ","))
				incr(i)
			}
			/* Suppression de la virgule finale */
			set(plac2, substring(plac2, 1, sub(strlen(plac2), 1)))
			set(coord, lookup(pt_coord1, plac2))
			if(eq(affcoord, 2)) {
				set(plat, lookup(pt_lat, plac2))
				set(plon, lookup(pt_lon, plac2))
			}
			if(eqstr(coord, "")) {
				set(coord, "(?)")
			}
			else {
				set(coord, concat("~ ", coord))
			}
		}
	}
	if(nestr(coord, "")) {
		set(affdist, "")
		if(and(nestr(coord, "(?)"), eq(affcoord, 2))) {
			set(dist, spdist(latdc, londc, plat, plon))
			if(ge(dist, 0.05)) {
				set(affdist, concat(" ", f(dist, 1), " km"))
			}
		}
		return(concat(decoup_plac(evt, decoupage, optdec), " ", coord, affdist))
	}
	else {
		return(decoup_plac(evt, decoupage, optdec))
	}
}
/* }}}1 */
proc printshort(perso) /* {{{1 */
{
	set(dates, "")
	if(date1, date(birth(perso))) {
		set(dates, concat("(", complexdate(date1)))
	}
	elsif(date1, date(baptism(perso))) {
		set(dates, concat("(", complexdate(date1)))
	}
	if(date2, date(death(perso))) {
		if(eqstr(dates, "")) {
			set(dates, concat("(+", complexdate(date2)))
		}
		else {
			set(dates, concat(dates, "-", complexdate(date2)))
		}
	}
	elsif(date2, date(burial(perso))) {
		if(eqstr(dates, "")) {
			set(dates, concat("(+", complexdate(date2)))
		}
		else {
			set(dates, concat(dates, "-", complexdate(date2)))
		}
	}
	if(nestr(dates, "")) {
		" " dates ")"
	}
}
/* }}}1 */
proc printbirth(perso) /* {{{1 */
{
	if(evt_mult) {
		call printbirth_mult(perso)
		return()
	}
	if(e, birth(perso)) {
		if (or(place(e), date(e))) {
			libbirt nettoie(complexdate(e))
			if(calrep) {
				set(dr, tocalrep(date(e), place(e)))
				if(nestr(date(e), dr)) {
					" (" nettoie(complexdate(dr)) ")"
				}
			}
			" " print_place(e) nln
			if(and(place(e), date(e))) {
				return()
			}
		}
		if(affnotes) {
			fornotes(e, note) {
				"{      " note "}" nln
			}
		}
	}
	if(e, baptism(perso)) {
		libbapt nettoie(complexdate(e)) 
		if(calrep) {
			set(dr, tocalrep(date(e), place(e)))
			if(nestr(date(e), dr)) {
				" (" nettoie(complexdate(dr)) ")"
			}
		}
		" " print_place(e) nln
		if(affnotes) {
			fornotes(e, note) {
				"{      " note "}" nln
			}
		}
	}
}
/* }}}1 */
proc printbirth_mult(perso) /* {{{1 */
{
	set(cpt_enr, 0)
	set(nochr, 0)
	fornodes(perso, e) {
		if(or(eqstr(tag(e), "BIRT"), eqstr(tag(e), "_BIRT"))) {
			if(or(place(e), date(e))) {
				incr(cpt_enr)
				if(gt(cpt_enr, 1)) {
					libbirt2
				}
				else {
					libbirt
					/* si la première naissance a un lieu et une
					   date, on ne cherche pas le baptême */
					if(and(date(e), place(e))) {
						set(nochr, 1)
					}
				}
				nettoie(complexdate(e))
				if(calrep) {
					set(dr, tocalrep(date(e), place(e)))
					if(nestr(date(e), dr)) {
						" (" nettoie(complexdate(dr)) ")"
					}
				}
				" " print_place(e)
				if(gt(cpt_enr, 1)) {
					" ?]"
				}
				nln
			}
			if(affnotes) {
				fornotes(e, note) {
					"{      " note "}" nln
				}
			}
		}
	}
	if(nochr) {
		return()
	}
	set(cpt_enr, 0)
	fornodes(perso, e) {
		if(or(eqstr(tag(e), "CHR"), eqstr(tag(e), "_CHR"))) {
			incr(cpt_enr)
			if(gt(cpt_enr, 1)) {
				libbapt2
			}
			else {
				libbapt
			}
			nettoie(complexdate(e)) 
			if(calrep) {
				set(dr, tocalrep(date(e), place(e)))
				if(nestr(date(e), dr)) {
					" (" nettoie(complexdate(dr)) ")"
				}
			}
			" " print_place(e)
			if(gt(cpt_enr, 1)) {
				" ?]"
			}
			nln
			if(affnotes) {
				fornotes(e, note) {
					"{      " note "}" nln
				}
			}
		}
	}
}
/* }}}1 */
proc printdeath(perso) /* {{{1 */
{
	if(evt_mult) {
		call printdeath_mult(perso)
		return()
	}
	set(e, death(perso))
	if(e) {
		/* Recherche des causes du décès */
		set(causedeath, cause(e))
		if(nestr(causedeath, "")) {
			set(causedeath, concat(causedeath, " "))
		}
		if(or(place(e), date(e))) {
			libdeat causedeath nettoie(complexdate(e))
			if(calrep) {
				set(dr, tocalrep(date(e), place(e)))
				if(nestr(date(e), dr)) {
					" (" nettoie(complexdate(dr)) ")"
				}
			}
			" " print_place(e) nln
			if(affnotes) {
				fornotes(e, note) {
				"{      " note "}" nln
				}
			}
			if(and(place(e), date(e))) {
				return()
			}
		}
	}
	if(e, burial(perso)) {
		libburi nettoie(complexdate(e))
		if(calrep) {
			set(dr, tocalrep(date(e), place(e)))
			if(nestr(date(e), dr)) {
				" (" nettoie(complexdate(dr)) ")"
			}
		}
		" " print_place(e) nln
		if(affnotes) {
			fornotes(e, note) {
				"{      " note "}" nln
			}
		}
	}
}
proc printdeath_mult(perso) /* {{{1 */
{
	set(cpt_enr, 0)
	set(noburi, 0)
	fornodes(perso, e) {
		if(or(eqstr(tag(e), "DEAT"), eqstr(tag(e), "_DEAT"))) {
			/* Recherche des causes du décès */
			set(causedeath, cause(e))
			if(nestr(causedeath, "")) {
				set(causedeath, concat(causedeath, " "))
			}
			if(or(place(e), date(e))) {
				incr(cpt_enr)
				if(gt(cpt_enr, 1)) {
					libdeat2
				}
				else {
					libdeat
					/* si le premier décès à un lieu et une
					   date, on ne cherche pas l'inhumlation */
					if(and(date(e), place(e))) {
						set(noburi, 1)
					}
				}
				causedeath nettoie(complexdate(e))
				if(calrep) {
					set(dr, tocalrep(date(e), place(e)))
					if(nestr(date(e), dr)) {
						" (" nettoie(complexdate(dr)) ")"
					}
				}
				" " print_place(e)
				if(gt(cpt_enr, 1)) {
					" ?]"
				}
				nln
				if(affnotes) {
					fornotes(e, note) {
						"{      " note "}" nln
					}
				}
			}
		}
	}
	if(noburi) {
		return()
	}
	set(cpt_enr, 0)

	fornodes(perso, e) {
		if(or(eqstr(tag(e), "BURI"), eqstr(tag(e), "_BURI"))) {
			incr(cpt_enr)
			if(gt(cpt_enr, 1)) {
				libburi2
			}
			else {
				libburi
			}
			nettoie(complexdate(e)) 
			if(calrep) {
				set(dr, tocalrep(date(e), place(e)))
				if(nestr(date(e), dr)) {
					" (" nettoie(complexdate(dr)) ")"
				}
			}
			" " print_place(e)
			if(gt(cpt_enr, 1)) {
				" ?]"
			}
			nln
			if(affnotes) {
				fornotes(e, note) {
					"{      " note "}" nln
				}
			}
		}
	}
}
/* printmar : affichage mariage {{{1 */
proc printmar(couple)
{
	set(cm, 0)
	set(nomarr, 1)
	set(valagnc, "")
	fornodes(fam(couple), mynode) {
		if(eqstr(tag(mynode), "MARC")) {
			set(nomarr, 0)
			set(valagnc, agnc(mynode))
			if(nestr(valagnc, "")) {
				set(valagnc, concat(valagnc, ", "))
			}
			libmarc
			set(cm, 1)
			fornodes(mynode, nodemarc) {
				if(eqstr(tag(nodemarc), "DATE")) {
					nettoie(complexdate(value(nodemarc)))
					if(calrep) {
						set(dr, tocalrep(date(e), place(e)))
						if(nestr(date(e), dr)) {
							" (" nettoie(complexdate(dr)) ")"
						}
					}
					" "
				}
				if(nestr(valagnc, "")) {
					valagnc
					set(valagnc, "")
				}
				if(eqstr(tag(nodemarc), "PLAC")) {
					print_place(mynode)
				}
			}
			nln
			if(affnotes) {
				fornotes(mynode, note) {
					"{      " note "}" nln
				}
			}
		}
	}
	if(e, marriage(fam(couple))) {
		/* On n'affiche pas le mariage si on a un contrat
		   et que l'année */
		set(nomarr, 0)
		extractdate(e, jj, mm, aa)
		if(and(cm, not(mm))) {
			return()
		}
		if(or(date(e), place(e))) {
			libmarr nettoie(complexdate(e))
			if(calrep) {
				set(dr, tocalrep(date(e), place(e)))
				if(nestr(date(e), dr)) {
					" (" nettoie(complexdate(dr)) ")"
				}
			}
			" " print_place(e) nln
			if(affnotes) {
				fornotes(e, note) {
					"{      " note "}" nln
				}
			}
		}
	}
	if(nomarr) {
		libnomarr nln
	}
}
/* getoccu : édition des professions {{{1 */
proc getoccu(perso)
{
	set(nboccu, 0)
	set(occu, "")
	set(nbtitl, 0)
	set(titl, "")
	set(valagnc, "")
	fornodes(inode(perso), mynode) {
		set(occu_dp, "")
		set(occu_plac, "")
		if(eqstr(tag(mynode),"OCCU")) {
			set(nboccu, add(nboccu, 1))
			set(valagnc, agnc(mynode))
			if(gt(nboccu, 1)) {
				set(occu, concat(occu, ", "))
			}
			set(occu, concat(occu, value(mynode)))
			extractdate(mynode, jj, mm, aa)
			if(aa) {
				set(occu_dp, concat(occu_dp, " (", d(aa)))
			}
			if(nestr(valagnc, "")) {
				if(eqstr(occu_dp, "")) {
					set(occu_dp, concat(" (", valagnc))
				}
				else {
					set(occu_dp, concat(occu_dp, "-", valagnc))
				}
			}
			if(place(mynode)) {
				set(occu_plac, decoup_plac(mynode, decoupage_occu, ""))
				if(eqstr(occu_dp, "")) {
					set(occu_dp, concat(" (", occu_plac))
				}
				else {
					set(occu_dp, concat(occu_dp, "-", occu_plac))
				}
			}
			if(nestr(occu_dp, "")) {
				set(occu_dp, concat(occu_dp, ")"))
			}
			set(occu, concat(occu, occu_dp))
		}
		else {
			if(eqstr(tag(mynode),"TITL")) {
				set(untitre, value(mynode))
				/* Recherche si on doit féminiser les titres */
				set(flagfem, 0)
				if(femin) {
					set(flagfem, eq(sex(perso), "F"))
				}
				if(titresgw) {
					set(untitre, formatgw(mynode, flagfem))
				}
				set(nbtitl, add(nbtitl, 1))
				if(gt(nbtitl, 1)) {
					set(titl,concat(titl, ", "))
				}
				/* GeneWeb met le nom associé au titre en note,
				un tag _NAME me semble préférable */
				if(titresgw) {
					fornodes(mynode, mynode2) {
						if(or(eqstr(tag(mynode2), "NOTE"), eqstr(tag(mynode2), "_NAME"))) {
							set(titl, concat(titl, value(mynode2), " "))
						}
					}
					/*
					fornotes(mynode, nom2) {
						set(titl, concat(titl, nom2, " "))
					}
					*/
				}
				set(titl,concat(titl, untitre))
				if(date(mynode)) {
					set(dd, nettoie(complexdate(mynode)))
					set(titl, concat(titl, " (", dd, ")"))
				}
				/*
				extractdate(mynode, jj, mm, aa)
				if(aa) {
					set(titl, concat(titl, " (", d(aa), ")"))
				}
				*/
			}
		}
	}
	if(nestr(titl,"")) {
		"    " titl nln
	}
	if(nestr(occu,"")) {
		"    " occu nln
	}
}
/* gestcert Gestion d'un tag incertitude de filiation {{{1 */

proc gestcert(perso)
{
	/* On recherche si les parents sont incertains */
	set(valcert, "")
	fornodes(inode(perso), mynode) {
		if(eqstr(tag(mynode), tagcert)) {
			set(valcert, value(mynode))
			/* Enregistrement du père */
			set(clecert, mul(ahnen, 2))
			insert(sosacert, d(clecert), valcert)
			/* Enregistrement de la mère */
			set(clecert, add(clecert, 1))
			insert(sosacert, d(clecert), valcert)
		}
		if(nestr(valcert, "")) {
			break()
		}
	}
	/* On recherche dans la table si la personne est incertaine */
	set(libcert, lookup(sosacert, d(ahnen)))
	if(nestr(libcert, "")) {
		set(libcert, concat(libcert, " "))
	}
}
/* gestcertdemoura Gestion d'un tag incertitude de filiation {{{1 */

proc gestcertdemoura(perso)
{
	/* On recherche si les parents sont incertains */
	set(valcert, "")
	fornodes(inode(perso), mynode) {
		if(eqstr(tag(mynode), tagcert)) {
			set(valcert, value(mynode))
		}
		if(nestr(valcert, "")) {
			break()
		}
	}
	if(nestr(valcert, "")) {
		valcert " "
	}
}
func addlinksdemoura(person) /* {{{1 */
{
	if(links) {
		if(eq(output_type, HTML)) {
			return(concat(" <a href=", qt(), "#", person, qt(), ">", person, "</a>"))
		}
		elsif(eq(output_type, LATEX)) {
			return(concat(" \\hyperlink{", person, "}{", person, "}"))
		}
		else {
			return(person)
		}
	}
	else {
		return(person)
	}
}
proc addlinks(person, number) /* {{{1 */
{
	if(eq(output_type, HTML)) {
		if(ne(number, 1)) {
			set(work, div(number, 2))
			" <a href=" qt() "#" d(work) qt() ">" libchil "</a>" 
		}
		if(par, father(person)) {
			if(or(implexe, not(before))) {
				set(work, mul(number, 2))
				" <a href=" qt() "#" d(work) qt() ">" libfath "</a>"
			}
		}
		if(par,mother(person)) {
			if(or(implexe, not(before))) {
				set(work, add(mul(number, 2), 1))
				" <a href=" qt() "#" d(work) qt() ">" libmoth "</a>"
			}
		}
	}
	/* En texte, une étoile indique l'absence des parents */
	elsif(eq(output_type, TXT)) {
		if(not(parents(person))) {
			" *"
		}
	}
	elsif(eq(output_type, LATEX)) {
		if(ne(number, 1)) {
			set(work, div(number, 2))
			" \\hyperlink{" d(work) "}{" libchil "}"
		}
		if(par, father(person)) {
			set(work, mul(number, 2))
			" \\hyperlink{" d(work) "}{" libfath "}"
		}
		if(par,mother(person)) {
			set(work, add(mul(number, 2), 1))
			" \\hyperlink{" d(work) "}{" libmoth "}"
		}
	}
	else {
		print("addlinks : type d'édition inconnu")
	}
}
proc printnom(pers) /* {{{1 */
{
	list(listname)
	set(prusuel, "")
	set(autnoms, "")
	set(unautnom, "")
	set(nomprin, "")
	set(npfx, "")
	set(afftitre, 0)
	extractnames(inode(pers), listname, nbpart, posname)
	fornodes(inode(pers), mynode) {
		if(eqstr(tag(mynode), "NAME")) {
			if(eqstr(nomprin, "")) {
				set(nomprin, value(mynode))
			}
			else {
				set(unautnom, value(mynode))
				if(eqstr(autnoms, "")) {
					set(autnoms, concat("(", unautnom))
				}
				else {
					set(autnoms, concat(autnoms, ", ", unautnom))
				}
			}
			fornodes(mynode,mynode2) {
				if(eqstr(tag(mynode2),"GIVN")) {
					set(prusuel, value(mynode2))
				}
				if(eqstr(tag(mynode2),"NPFX")) {
					set(npfx, value(mynode2))
				}
			}
		}
	}
	/* TODO : vérifier place pour NPFX */
	if(yearonly) {
		set(npfx, "")
		set(autnoms, "")
		set(titre, title(pers))
	}
	/* TODO : tester la présence de NPFX dans NAME */
	if(ne(npfx, "")) {
		npfx " "
	}
	forlist(listname, ws, elem) {
		if(eq(posname, elem)) {
			if(yearonly) {
				if(nestr(titre, "")) {
					if(index(titre, ws, 1)) {
						bold titre fbold
						set(afftitre, 1)
					}
					else {
						bold ws fbold
					}
				}
				else {
					bold ws fbold
				}
			}
			else
			{
				bold ws fbold
			}
		}
		else {
			if(eq(prusuel,ws)) {
				usuel ws fusuel sp()
			}
			else {
				ws sp()
			}
		}
	}
	if(nestr(autnoms, "")) {
		set(autnoms, concat(autnoms, ")"))
		sp() autnoms
	}
	if(yearonly) {
		if(not(afftitre)) {
			if(nestr(titre, "")) {
				" " titre
			}
		}
	}
}

proc entetelatex() /* {{{1 */
{
	"\\documentclass[a4paper,8pt]{article}\n"
	"\\usepackage[T1]{fontenc}\n"
	"\\usepackage{ifpdf}\n"
	"%\\usepackage[latin1]{inputenc}\n"
	"\\usepackage[utf8]{inputenc}\n"
	"\\usepackage[frenchb,english]{babel}\n"
	"\\usepackage{vmargin} %% Multicolonnage et \\setmarginsrb\n"
	"\\ifpdf\n"
	"\\usepackage{aeguill}\n"
	"\\usepackage[pdftex,colorlinks,%\n"
	"linkcolor=blue,%\n"
	"\\urlcolor=blue]{hyperref}\n"
	"\\fi\n"
	"\\begin{document}\n"
	"\\selectlanguage{frenchb}\n"
	"\\setlength{\\parindent}{0pt}\n"
}
/* }}}1 */
/*
vim:fdm=marker:ts=4:sw=4
*/
