/* {{{1
** @progname       book-latex-pt (fr)
** @author         Nicklaus (vo), Patrick Texier (vf)
** @version        5.03 of 2009-04-11
** @category       
** @output         LaTeX,pdfLaTeX
** @description
**
** Ascendance ou descendance rédigée en LaTeX. De très
** nombreuses parties ont été réécrites.
**
** Patrick Texier
** 5.1  26/04/2009
** - Utilisation de decoup_plac pour réorganiser les lieux
** 5.03 11/04/2009
** - Correction de l'édition des notes : ils manquait \\ pour
**   faire les sauts de ligne avec CONT.
** 5.02 03/10/2008 TODO 
** - Réindentation complète
** - Suppression des fonctions inutiles en français
** - Affichage de l'auteur avant le titre dans la bibliographie.
** - Passage de AGE en gedcom 5.5.
** 5.01 19/07/2008
** - Sortie en UTF-8.
** - Affichage des titres de noblesse.
** - Remise en conformité gecdom des couples non mariés.
**
** 4.51 25/06/2004
** - Modifs de Guy Gentil
**
** Modifications Thierry Houx <thierry.houx@free.fr>
** 4.5
** - Ajout à \documentclass le format papier a4paper
** - Modif de \textheight de 8.9 à 9.7in
** - 06/09/03 Voir ligne 777, optimisation utilisation page A4
**
** Modifications Patrick TEXIER <p.texier@genindre.org>
**
** 4.4 aout 2003
**   Affichage des années de baptèmes/inhumations si on n'a pas les naissances/decès dans les arbres.
** 4.3 7 mars 2003
**	 commandes pour pdflatex
**   A revoir pour utiliser \ifpdf
** 4.2 18 décembre 2002
**
**   Possibilité de réorganiser les lieux.
**   Prise en compte des dates de naissance / décès pour
**   l'index des personnes.
**
** 4.0 24 décembre 2001
**
** - Traduction en français
** - Modification des bibliothèques LaTeX (merci à Françoise Marre-Fournier)
** - Plus d'affichage des dèces à vide (tag 1 DEAT Y)
** - Simplication de certaines lourdeurs du texte et remplacement
**   par des cf.
** - Gestion du vocabulaire selon le sexe (4.0)
**
}}}1 */

char_encoding("UTF-8")
include("ptfunct.li")
include("ptinit.li")

/* Declarations {{{1 */

global(maxgenprint)      /* number of generations to print full info for.*/
global(atmax_generation) /* used so we don't print full birthdates of living
			     individuals at the MAX-th generation */
global(ancestormode)
global(pdfmode)
global(notes_text_mode)
global(notes_pied)
global(eventPlaceTable)
global(atAddrValue)
global(eventNameTable)
global(eventNameTableF)
global(eventNameTableP)
global(in)
global(out)
global(idex)
global(stab)
global(powValue)
global(namereturn)
global(excurlist)
global(sourceList)
global(bibList)
global(bibTable)
global(figureCiteList)
global(figureNodeList)
global(gotValue)
global(gottenNode)
global(gottenValue)
global(traitEven)
global(dayNumber)
global(previousDayNumber)
global(not_married_flag)
global(dumpplacetable_each_gen)
global(hadsplitnote)
global(force_desc_chart)
global(global_dead)	/* used at the MAX-th generation so we know if indi is dead*/
global(decpl) /* Redécoupage du lieu */
global(optpl) /* Options de redécoupage du lieu */
global(listelieu)
global(ilieu)
global(indexdates)
global(npfx) /* Préfixe du nom */

global(date1) /* Dates pour les arbres */
global(date2)
global(trdate)
global(nspou)
global(cptspou)

global(figureFlag)
global(tabance) /* Table des personnes dont on veut des arbres ascendants */
global(tabdesc) /* Table des personnes dont on veut des arbres descendant */
global(tabexcu) /* Table des personnes dont on trace la ligne agnatique */

proc main () /* {{{1 */
{
	call pt_init()
	table(tabance)
	table(tabdesc)
	table(tabexcu)
	call charge_tables()
	list (headlist)
	table(stab)    /* Table of numbers for each individual */
	list (bibList)
	list (excurlist)
	table (bibTable)
	list (figureCiteList)
	list (figureNodeList)
	list (sourceList)

	set(force_desc_chart,0)	

	if (1)  {
		getint (ancestormode,
				"Entrez 0 pour descendants, 1 pour ascendants")
	}  else  {
		set (ancestormode, 0)
	}
	if (1)  {
		getint(traitEven,
				"Traiter les évènements utilisateur (1 EVEN): 0=Non, 1=Oui")
	} else {
		set (traitEven, 1)
	}
	if (1)  {
		getint (notes_text_mode,
				"Book Text:1='1 TEXT'; 2= all '1 NOTE'; 3= !-tag '1 NOTE's")
	}  else  {
		set (notes_text_mode,1)
	}
	if(1) {
		getint(notes_pied, "Notes : 0 = dans le texte, 1 en pied de page, 2 à la fin")
	}
	else {
		set(notes_pied, 0)
	}
	if (1)  {
		getstr(decpl, "Ordre des lieux (ex:4213) :")
		getstr(optpl, "Option du découpage des lieux (SI) :")

	} else {
		set (decpl, "")
		set (optpl, "S")
	}
	if (0)  {  /* change this to  "if (1)" to turn this query on. */
		getint (dumpplacetable_each_gen,
				"Enter 1 to reset place name table each generation, 0 to not")
	}  else  {
		set(dumpplacetable_each_gen,1)
	}

	set (maxgenprint,999)
	if (eq(0,ancestormode)){
		if (1)  {	
			getint (maxgenprint,
					"Max generations for descendency books")
		}  else  {
			set (maxgenprint,999)
		}
	}
	if (1) {
		getint(pdfmode, "0=Sortie Latex, 1=Sortie PDFLatex")
	}
	else {
		set(pdfmode, 0)
	}

	getindi(indi)  /* Get the individual to start with */
	set(familycount,0)
	while (indi){
		set(familycount,add(familycount,1))
		enqueue(headlist, indi)
		set(indi,0)
		getindi(indi)  /* Get next */
	}
	if(1) {
		getstr(author, "Entrez le(s) auteur(s) de ce document :")
	}
	else {
		set(author, "")
	}

	/* Print preamble.  Feel free to change this to suit your tastes. */
	"\\documentclass[a4paper,twocolumn,twoside,titlepage]{book}\n"	/* LaTeX 2e */
	/*"\\documentstyle[twocolumn,makeidx]{book}\n"*/
	"\\pagestyle{myheadings}\n\n"
	"% Enable UTF-8 charset" nl()

	/* Pour pdf */
	if(pdfmode) {
		"\\usepackage[T1]{fontenc}\n"
		/* On peut mettre pxfonts pour fontes Palatino au lieu de Times */
		"\\usepackage{txfonts}\n"
		/* "\\usepackage[latin1]{inputenc}\n" */
		"\\usepackage[utf8]{inputenc}\n"
		"\\usepackage[frenchb]{babel}\n"
		/* Liens hypertexte */
		"% Liens hypertexte\n"
		"\\usepackage[pdftex,bookmarks,colorlinks]{hyperref}\n"
	}
	else {
		"\\usepackage[T1]{fontenc}\n"
		/* "\\usepackage[latin1]{inputenc}\n" */
		"\\usepackage[utf8]{inputenc}\n"
		"\\usepackage[frenchb]{babel}\n"
	}
	/* Ajout du package pour les notes en fin */
	if(eq(notes_pied, 2)) {
		"\\usepackage{endnotes}\n"
		"\\let\\footnote=\\endnote\n"
	}
	"% Shrink the margins to use more of the page.\n"
	"% This is taken from fullpage.sty, which is on some systems.\n"
	"% Modification Thierry Houx pour une meilleure utilisation\n"
	"% de la surface d'une page A4\n"
	"\\usepackage{anysize}\n"
	"\\marginsize{1.5cm}{1.5cm}{1.5cm}{1.5cm}\n"
	"\\textheight 25cm\n"
	"% --- Mise en commentaires des anciennes instructions. ---\n"
	"% \\topmargin 0pt\n"
	"% \\advance \\topmargin by -\\headheight\n"
	"% \\advance \\topmargin by -\\headsep\n"
	"% Modification Thierry Houx : textheight 8.9->9.7\n"
	"%\\textheight 8.9in\n"
	"% \\oddsidemargin 0pt\n"
	"% \\evensidemargin \\oddsidemargin\n"
	"% \\textwidth 6.5in\n\n"
	"% --- Fin de mise en commentaires ---\n"
	"\\newcounter{childnumber}\n\n"
	"% The \\noname command is needed because TeX doesnt like underscores.\n"
	"\\newcommand{\\noname}{\\underline{\\ \\ \\ \\ \\ }}\n\n"
	"\\newcommand{\\nodate}{\\underline{\\ \\ \\ \\ }}\n\n"
	"% Environment for printing the list of children.\n"
	"\\newenvironment{childrenlist}"
	"{\\begin{small}\\begin{list}{\\sc\\roman{childnumber}.}"
	"{\\usecounter{childnumber}\\setlength{\\leftmargin}{0.5in}"
	"\\setlength{\\labelsep}{0.07in}\\setlength{\\labelwidth}{0.43in}} }"
	"{\\end{list}\\end{small}}\n\n"
	"% The following commands are used to create the index.\n"
	"\\newcommand{\\bold}[1]{{\\bf #1}}\n"
	"\\newcommand{\\bfit}[1]{{\\bf\\it #1}}\n"
	"%%\\newcommand{\\see}[2]{{\\it see #1}} %not needed with makeidx.sty\n\n" 
	"% Command to use at the beginning of each new generation.\n"
	if (ancestormode){
		"\\newcommand{\\generation}[2]"
		"{\\newpage\\begin{center}{\\huge\\bf Génération #1}\\end{center}"
		"\\vspace{3ex}\\setcounter{footnote}{0}"
		"\\markright{Les ancêtres de #2" "\\hfill Génération #1\\hfill\\ }"
		"}\n\n"
	}
	else{
		"\\newcommand{\\generation}[2]"
		"{\\newpage\\begin{center}{\\huge\\bf Génération #1}\\end{center}"
		"\\vspace{3ex}\\setcounter{footnote}{0}"
		"\\markright{Les descendants de #2" "\\hfill Génération #1\\hfill\\ }"
		"}\n\n"
	}
	"\\newcommand{\\image}[4]"
	"{\\begin{figure}\n\\centerline{\\psfig{figure=#1,height=#4}}\n"
	"\\label{#3}\n"
	"\\caption{#2}\n\\end{figure}}\n"
	"\\newcommand{\\imwide}[4]"
	"{\\begin{figure*}\n\\centerline{\\psfig{figure=#1,height=#4}}\n"
	"\\label{#3}\n"
	"\\caption{#2}\n\\end{figure*}}\n"


	"\\makeindex\n\n"
	"\n\\input{tree}\n" /* needed for making descendent trees */
	"\\begin{document}\n\n"

	/*******************************************/
	/* Make the title */
	/*******************************************/
	"\\title{ "
	if (gt(familycount,1)) {" Les familles "} else {" La famille "} 
	forlist(headlist,head,localcount){
		if (gt(localcount,1)){
			if (gt(familycount,2)){ /* don't say "a, and b." */
				", "
			}
			if (eq(localcount,familycount)){ " et "}
		}
		surname(head)
	}
	"}\n"

	"\\author{" author "}\n"
	"\\date{\\today}\n"
	"\\maketitle\n"

	"\\clearpage\n"
	"\\onecolumn\n"
	"\\pagestyle{empty}\n"
	"\\mbox{ }\n"
	"\\vfill\n"
	"\\begin{center}\n"
	"Copyright \\copyright \\ \\today \\  " author "\\\\" 
	getstr(copyplace, "Enter the place for the copyright notice:")
	copyplace "\n"

	"\\end{center}\n"
	"\\clearpage\n"
	"\\pagestyle{myheadings}\n"
	"\\twocolumn\n"

	"%\\setcounter{page}{1}\n"
	"\\tableofcontents"

	getstr(intro, "File that contains introduction (if any):")
	if (ne(strcmp(intro, ""), 0)) {
		"\\input{" intro "}\n"
	}

	table (eventNameTable)
	table (eventPlaceTable)
	table (eventNameTableF)
	table (eventNameTableP)

	insert (eventNameTable, "BIRT", "est né")
	insert (eventNameTable, "ADOP", "a été adopté")
	insert (eventNameTable, "BAPM", "a été baptisé")
	insert (eventNameTable, "CHR",  "a été baptisé")
	insert (eventNameTable, "DEAT", "est décédé")
	insert (eventNameTable, "BURI", "a été inhumé")
	insert (eventNameTable, "CREM", "a été incinéré")
	insert (eventNameTable, "GRAD", "")/* left blank since it is done
										  as a separate case */
	insert (eventNameTable, "NATU", "a été naturalisé")
	insert (eventNameTable, "CHRA", "a été baptisé (adulte)")
	insert (eventNameTable, "CENS", "a été recensé")
	insert (eventNameTable, "ORDN", "a été ordonné")
	insert (eventNameTable, "RELI", "")
	insert (eventNameTable, "RESI", "habitait")
	insert (eventNameTable, "CONL", "a été confirmé")
	insert (eventNameTable, "CONF", "a été confirmé")
	insert (eventNameTable, "BLES", "a été béni")
	insert (eventNameTable, "BASM", "was bat mitzvah-ed")
	insert (eventNameTable, "BARM", "was bar mitzvah-ed")
	/* these two Will related things come out kind of icky because
	   I just always use plain pronouns like he, she, not
	   possessive ones, so I have to say "he wrote  a will"
	   instead of "his will was dated" */
	insert (eventNameTable, "PROB", "had a will probated")
	insert (eventNameTable, "WILL", "a testé")
	insert (eventNameTable, "RETI", "retired")
	/* for my usage LIVD */

	insert (eventNameTableF, "BIRT", "est née")
	insert (eventNameTableF, "ADOP", "a été adoptée")
	insert (eventNameTableF, "BAPM", "a été baptisée")
	insert (eventNameTableF, "CHR",  "a été baptisée")
	insert (eventNameTableF, "DEAT", "est décédée")
	insert (eventNameTableF, "BURI", "a été inhumée")
	insert (eventNameTableF, "CREM", "a été incinérée")
	insert (eventNameTableF, "GRAD", "")/* left blank since it is done
										   as a separate case */
	insert (eventNameTableF, "NATU", "a été naturalisée")
	insert (eventNameTableF, "CHRA", "a été baptisée (adulte)")
	insert (eventNameTableF, "CENS", "a été recensée")
	insert (eventNameTableF, "ORDN", "a été ordonnée")
	insert (eventNameTableF, "RELI", "")
	insert (eventNameTableF, "RESI", "habitait")
	insert (eventNameTableF, "CONL", "a été confirmée")
	insert (eventNameTableF, "CONF", "a été confirmée")
	insert (eventNameTableF, "BLES", "a été bénie")
	insert (eventNameTableF, "BASM", "was bat mitzvah-ed")
	insert (eventNameTableF, "BARM", "was bar mitzvah-ed")
	/* these two Will related things come out kind of icky because
	   I just always use plain pronouns like he, she, not
	   possessive ones, so I have to say "he wrote  a will"
	   instead of "his will was dated" */
	insert (eventNameTableF, "PROB", "had a will probated")
	insert (eventNameTableF, "WILL", "a testé")
	insert (eventNameTableF, "RETI", "retired")
	/* for my usage _RESI : adresse couple */
	insert (eventNameTableP, "_RESI", "habitaient")

	indiset(idex)

	set(out, 1)
	set(in, 1)

	dayformat (2)
	monthformat (8)
	dateformat (0)
	while (indi, dequeue(headlist)) {
		if (ancestormode){
			call  ancestor_chapterproc(indi)
		}
		else {
			call  chapterproc(indi)
		}
	}
	if(eq(notes_pied, 2)) {
		"\\onecolumn\n"
		"\\newpage\n"
		"\\begingroup\n"
		"\\parindent 0pt\n"
		"\\parskip 2ex\n"
		"\\def\\enotesize{\\normalsize}\n"
		"\\theendnotes\n"
		"\\endgroup\n"
	}
	set(basename, 
			substring(outfile(), 1, sub(index(outfile(), ".tex", 1), 1)))

	/* Output bibliography commands */
	if (not (empty (bibList))) {
		"\n\n\\onecolumn"
		"\n\\cleardoublepage"
		"\n\\label{Bibliographie}"
		"\n\\addcontentsline{toc}{chapter}{Bibliographie}"
		"\n\\begin{thebibliography}{9.99}"
		"\n\\input{" basename "-bib.tex}"
		"\n\\end{thebibliography}"
	}
	"\n\n\\cleardoublepage"
	"\n\\label{Index}"
	"\n\\addcontentsline{toc}{chapter}{Index}"
	"\n\\input{" basename ".ind}"

	"\n\n\\end{document}\n"

	/* Output bibliography file */
	print ("\n\nCreating support files ...")
	if (not (empty (bibList))) {
		newfile (concat (basename, "-bib.tex"), 0)
		print ("writing to : ")
		print("\n")
		print(concat (basename, "-bib.tex"))
		print("\n")
		while (b, dequeue (bibList)) { b }
	}
}
/* }}} */
proc charge_tables() /* {{{1 */
{
	set(bidon, 0) /* LifeLines n'aime pas les proc vides */
	/*
	insert(tabance, "I30278", 1)
	insert(tabance, "I30312", 1)
	insert(tabance, "I31245", 1)
	insert(tabance, "I30324", 1)
	insert(tabance, "I31253", 1)
	insert(tabance, "I31260", 1)
	insert(tabance, "I31274", 1)
	insert(tabance, "I31291", 1)
	insert(tabance, "I30334", 1)
	insert(tabance, "I30330", 1)
	insert(tabance, "I31339", 1)
	insert(tabexcu, "I30278", 1)
	*/
}
/* }}}1 */
proc chapterproc(topguy) /* {{{1 */
{

	list(ilist)    /* List of individuals */
	list(glist)    /* List of generation for each individual */
	set(last_grandparents,0)
	indiset(grandparentset)
	indiset(hisset)
	indiset(last_grandparentset)
	/*
	set (chapterTitle, concat ("La famille de ", name (topguy)))
	*/
	set(chapterTitle, concat("La famille de ", givens(topguy), " ", surname(topguy)))

	"\n\\chapter{" chapterTitle "}" "\n"

	enqueue(ilist, topguy)
	enqueue(glist, 1)
	set(curgen, 0)
	set(printed_brace,0)
	set(just_printed_brace,0) 

	/* we have to do this add1 once for the topguy of each chapter
	   We used to start out with "in" initialized to 2, but that made
	   the numberings bad when there were multiple chapters, so now
	   we init to 1 and do this +1 here */
	set (in, add (in, 1))

	set (hadsplitnote,0)
	set (this_level_hadsplitnote,0)

	while (indi, dequeue(ilist)) {
		/* This is where we implement the "Chapter Split".  The idea is,
		   that if you put a BOOKCHAPSPLIT note on the head of a line, then
		   each of his children will head up their own chapters with
		   the children of that line as Generation 1 in their respective chapters. */
		if (eq(1,this_level_hadsplitnote)){
			call chapterproc(indi)
		}
		else{
			set(thisgen, dequeue(glist))
			if (ne(curgen, thisgen)) {
				/* If we are starting a new generation, close off brace
				   from previous gen. if necessary */
				if (printed_brace){
					"\n\\nobreak"
					"\n" "$\\underbrace{\\hspace*{3in}}$" "\n\n"
					set(printed_brace,0)
				}

				if (dumpplacetable_each_gen){  table (eventPlaceTable) }

				print("Génération ") print(d(thisgen)) print("\n")
				"\n\n\\generation{" d(thisgen) "}"
				"{" givens(topguy) " " surname(topguy) "}" "\n"
				"\n\\addcontentsline{toc}{section}{Génération " d(thisgen) "}\n"	
				set(curgen, thisgen)
				set(last_grandparents,0)
				indiset(last_grandparentset)
				set(printed_brace,0)
				if (eq(curgen,maxgenprint)){
					set(atmax_generation,1)
				}
				else {
					set(atmax_generation,0)
				}
			}
			/* decide if we have the same grandparents or not */
			/* I try to group people  together with over/under braces
			   for people descended from the same grandparent in this descendency */
			/* rather than remember who belongs to what line, I just look
			   at all their grandparents and if they overlap with the grandparents
			   of the previous person, then I assume I'm on the same line.
			   This isn't always true, but it is a start, at least. */
			if (gt(curgen,3)){
				if (eq(0,last_grandparents)){
					"\n" "$\\overbrace{\\hspace*{3in}}$" "\n"
					set(printed_brace,1) 
					set(just_printed_brace,1) 
					indiset(hisset)
					addtoset(hisset,indi,1)	
					set(grandparentset,parentset(parentset(hisset)))
					set(last_grandparentset,grandparentset)
					set(last_grandparents,1)
				}
				else{
					indiset(hisset)
					addtoset(hisset,indi,1)	
					set(grandparentset,parentset(parentset(hisset)))
					set(doit,1)
					indiset(extraSet)
					set(extraSet,intersect(grandparentset,last_grandparentset))
					forindiset(extraSet,joe,a,b){
						set(doit,0)
					}
					if (doit){
						if (printed_brace){
							"\n\\nobreak"
							"\n" "$\\underbrace{\\hspace*{3in}}$" "\n\n"
						}
						"\n" "$\\overbrace{\\hspace*{3in}}$" "\n\n"
						set(printed_brace,1) 
						set(just_printed_brace,1) 
						/* also reset the place table after each set of grandchildren.
						   This makes it repeat the whole location name the next time
						   it sees any location. Otherwise, it can get too far from the
						   introduction of the place for my liking. */
						if (dumpplacetable_each_gen){  table (eventPlaceTable) }
					}
					set(last_grandparentset,grandparentset)
					set(last_grandparents,1)

				}
			}

			print(d(out), " ")
			/* print(name(indi)) */
			set(npfx, get_npfx(indi))
			if(nestr(npfx, "")) {
				print(npfx, " ")
			}
			print(givens(indi), " ", surname(indi))
			print("\n")

			/* only do the vspace between people if there was no overbrace printed.
			   Otherwise there is too much white space and it looks icky. */
			if(eq(0,just_printed_brace)){
				"\n\\vspace{3ex}\\ \\\\"
			}
			set(just_printed_brace,0) 

			"\\begin{center}{\\large\\bf " d(out) "\\ "
			/* if(nestr(npfx, "")) {
				npfx " "
			} */
			givens(indi) " " surname(indi)
			"}\\end{center}\n"
			"\\nobreak\n"
			insert(stab, key(indi), out)
			/* Affichage du préfixe de nom */
			if(nestr(npfx, "")) {
				if(eqstr(sex(indi), "F")) {
					"La "
				}
				else {
					"Le "
				}
				npfx " "
			}

			call longvitals(indi, 1, 2)
			if (hadsplitnote){ set (this_level_hadsplitnote,1)}

			addtoset(idex, indi, 0)
			set(out, add(out, 1))
			/* check whether the children we are about to print are at the
			   Max generation */
			set(save_atmax_generation,atmax_generation)
			if (eq(add(curgen,1),maxgenprint)){
				set(atmax_generation,1)
			}

			families(indi, fam, spouse, nfam) {
				"\n\n"
				if (eq(0, nchildren(fam))) {

					call texname(indi, inode(indi), 0) "\\ et "
					if (spouse) {
						call texname(spouse, inode(spouse), 0)
					} else {
						"\\noname"
					}
					call havehadchildren(indi, spouse)
				} elsif (and(spouse, lookup(stab, key(spouse)))) {
					"Les enfants de " call texname(indi, inode(indi), 0) "\\ et "
					call texname(spouse, inode(spouse), 0) "\\ sous donnés sous "
					call texname(spouse, inode(spouse), 0)
					"~(" d(lookup(stab, key(spouse))) ").\n"
				} else {
					"Enfants de " call texname(indi, inode(indi), 0) "\\ et "
					if (spouse) {
						call texname(spouse, inode(spouse), 0)
					} else {
						"\\noname"
					}
					":\n\\begin{childrenlist}\n"
					children(fam, child, nchl) {
						set(haschild, 0)
						families(child, cfam, cspou, ncf) {
							if (ne(0, nchildren(cfam))) { set(haschild, 1) }
						}
						if (and(haschild,lt(curgen,maxgenprint))) {
							if (not(lookup(stab, key(child)))){
								enqueue(ilist, child)
								enqueue(glist, add(1, curgen))
								"\n\\item[{\\bf " d(in) "}\\ \\hfill"
								"\\addtocounter{childnumber}{1}"
								"{\\sc\\roman{childnumber}}.]"
								set (in, add (in, 1))
								set(npfx, get_npfx(child))
								if(nestr(npfx, "")) {
									if(eqstr(sex(child), "F")) {
										"La "
									}
									else {
										"Le "
									}
									npfx " "
								}
								call shortvitals(child)
							}
							else {
								"\n\\item[{\\bf " d(lookup(stab, key(child))) "}\\ \\hfill"
								"\\addtocounter{childnumber}{1}"
								"{\\sc\\roman{childnumber}}.]"
								set(npfx, get_npfx(child))
								if(nestr(npfx, "")) {
									if(eqstr(sex(child), "F")) {
										"La "
									}
									else {
										"Le "
									}
									npfx " "
								}
								call shortvitals(child)
								"  Le détail de cette famille a déja été donné."
							}
						} else {
							if (haschild){
								set(force_desc_chart,1)
							}
							"\n\\item "
							set(npfx, get_npfx(child))
							if(nestr(npfx, "")) {
								if(eqstr(sex(child), "F")) {
									"La "
								}
								else {
									"Le "
								}
								npfx " "
							}

							call longvitals(child, 0, 1)
							set(force_desc_chart,0)
							addtoset(idex, child, 0)
						}
					}
					"\\end{childrenlist}\n"
				}
			}
			set(atmax_generation,save_atmax_generation)

			if (eq (indi,topguy)){
				set (descFigureLabel, concat (key (indi), "-figure-desc"))
				"\nUn arbre des descendants de ce couple est imprimé à la "
				"figure~\\ref{"   descFigureLabel   "}."
				"\n\\begin{figure*}\n"
				"\\centering\n"
				call desc_chart_main3(indi)
				"\n\\caption{Descendants de " fullname(indi,0,1,99) "~({\\bf "
				d(lookup(stab, key(indi))) "})}" nl()
				"\\label{" descFigureLabel "}"
				"\\end{figure*}\n"
			}
		}
	}
	/* Close off the last braces if necessary */

	if (printed_brace){
		"\n\\nobreak"
		"\n" "$\\underbrace{\\hspace*{3in}}$" "\n\n"
	}
	set(printed_brace,0)

	while (indi, dequeue(excurlist)) {
		call excursion(indi)
	}
} 

/* Run this routine if you want an ahnentafel style report for the
   individuals named */
/* 1}}} */
proc ancestor_chapterproc(topguy)
{

	list(ilist)    /* List of individuals */
	list(glist)    /* List of generation for each individual */
	list(alist)
	set (chapterTitle, 
			concat ("Les ancêtres de ", fullname (topguy, 0, 1, 99)))

	"\n\\chapter{" chapterTitle "}" "\n"

	enqueue(ilist, topguy)
	enqueue(alist,1)
	enqueue(glist, 1)
	set(curgen, 0)
	insert(stab, key(topguy), 1)

	while (indi, dequeue(ilist)) {
		set(ahnen, dequeue(alist))
		set(thisgen, dequeue(glist))
		if (ne(curgen, thisgen)) {
			print("Génération ") print(d(thisgen)) print("\n")
			"\n\n\\generation{" d(thisgen) "}" "{" fullname(topguy, 0, 1, 99) "}" "\n"
			"\n\\addcontentsline{toc}{section}{Génération " d(thisgen) "}\n"	
			set(curgen, thisgen)
			/* reset the place table at each generation if asked to. */
			if (dumpplacetable_each_gen){  table (eventPlaceTable) }
		}
		print(d(ahnen)) print(" ") print(name(indi)) print("\n")

		"\n\\vspace{3ex}\\ \\\\"

		"\\begin{center}{\\large\\bf " d(ahnen) "\\ "
		name(indi) "}\\end{center}\n"

		/****************************************************************/
		/* first, enqueue his parents onto the lists so their numbers
		   will be printed out in the description of "indi" */
		/* also includes a check to see if indi's parents are already
		   there such as will happen when cousins marry. */
		set(print_dad_note,0)
		set(print_mom_note,0)

		if (par,father(indi)) {
			if (not(lookup(stab,key(par)))){
				enqueue(ilist, par)
				enqueue(alist, mul(2,ahnen))
				enqueue(glist, add(curgen, 1))
				insert(stab, key(par), mul(2,ahnen))
			}
			else {
				set(print_dad_note,key(par))
			}
		}
		if (par,mother(indi)) {
			if (not(lookup(stab,key(par)))){
				enqueue(ilist, par)
				enqueue(alist, add(1,mul(2,ahnen)))
				enqueue(glist, add(curgen, 1))
				insert(stab, key(par), add(1,mul(2,ahnen)))
			}
			else {
				set(print_mom_note,key(par))
			}
		}

		/****************************************************************/
		/* now to print out info about this person */

		call longvitals(indi, 1, 2)

		addtoset(idex, indi, 0)
		families(indi, fam, spouse, nfam) {
			"\n\n"
			if (eq(0, nchildren(fam))) {
				call texname(indi, inode(indi), 0) "\\ et "
				if (spouse) {
					call texname(spouse, inode(spouse), 0)
				} else {
					"\\noname"
				}
				call havehadchildren(indi, spouse)
			} elsif (and(female(indi),and(spouse, lookup(stab, key(spouse))))) {
				/* note that the form of that if is different here than in
				   descendent charts.  It is different because we explicity
				   form the queue by adding the father before the mother.
				   Thus, for the parent-set, the children will be printed 
				   under the father. We don't check to see if the father's
				   spouse had them previously printed because that would
				   only happen if a different (non-ancestor) wife also
				   happened to be an ancestor from a different branch, which
				   could happen, but has to be pretty rare.  (E.g. your
				   dad's dad marries your mom's mom for the 2nd marriage for both
				   of them, something like that. Ick.) */
				"Enfants de " call texname(indi, inode(indi), 0) "\\ et "
				call texname(spouse, inode(spouse), 0) "\\ cf.~"
				"({\\bf " d(lookup(stab, key(spouse))) "}).\n"
			} else {
				"Enfants de " call texname(indi, inode(indi), 0) "\\ et "
				if (spouse) {
					call texname(spouse, inode(spouse), 0)
				} else {
					"\\noname"
				}
				":\n\\begin{childrenlist}\n"
				children(fam, child, nchl) {
					set(haschild, 0)
					families(child, cfam, cspou, ncf) {
						if (ne(0, nchildren(cfam))) { set(haschild, 1) }
					}
					"\n\\item "
					if (not(lookup(stab, key(child)))){
						call longvitals(child, 0, 1)
						addtoset(idex, child, 0)
					}
					else {
						call shortvitals(child)
						"  cf.~"
						"({\\bf "
						d(lookup(stab, key(child))) "})" "."
					}
				}
				"\\end{childrenlist}\n"
			}
		}
		/* if his parents are not numbered as expected, tell 'em so. */
		if(ne(0,print_dad_note)){
			"\n Notez que son père"
			"~({\\bf "
			d(lookup(stab, print_dad_note)) "})"
			" n'a pas le "
			"numéro Sosa habituel à cause d'un implexe.\n"

		}
		if(ne(0,print_mom_note)){
			"Notez que sa mère" 
			"~({\\bf "
			d(lookup(stab, print_mom_note)) "})"
			" n'a pas le "
			"numéro Sosa habituel à cause d'un implexe.\n"
			"\n"
		}

		if (eq (indi,topguy)){
			call pedigreeFigure (indi)
			if (strcmp (pedigreeFigureLabel, "")) {
				pn (indi, 2)
				" ascendance est illustrée figure \\protect\\ref{" 
				pedigreeFigureLabel "}."
			}
		}
	}
}


/* shortvitals(indi):  Displays the short form of the vital statistics (birth
   and death only) of an individual. */

proc shortvitals(indi)
{
	call resetdayplace()
	call texname(indi, inode(indi), 1)
	set(b, birth(indi))
	set(d, death(indi))
	set(sexe, sex(indi))

	set(local_dead,global_dead) /* save for restore */
	set(global_dead,d)

	if (and(b, long(b))) {
		call process_event(b, sexe) /* not more using long(d) */
		if (and(d, or(date(d), place(d)))) {" et " pn(indi,1) call process_event(d, sexe) }
	}
	else{ /* know death info, not birth*/
		if (and(d, or(date(d), place(d)))) {call process_event(d, sexe) }
	}
	"."
	set(global_dead,local_dead) /* restore */
}


/* longvitals(i, name_parents, name_type)
   Prints out the complete vital statistics of the individual (i).  If
   name_parents is not 0, then the names of the parents of the individual will
   be printed.  The parameter name_type is passed to texname.  The GEDCOM tags
   are divided into ones that would likely occur before getting married and
   ones that would likely occur after getting married.  Within the two sets
   they are printed in the order in which they appear in the database.  I
   haven't yet figured out a convenient way of indicating the sex. */

proc longvitals(i, name_parents, name_type)
{
	call resetdayplace()

	set(local_dead,global_dead) /* save for restore */
	set(global_dead,death(i))

	call texname(i, inode(i), name_type)  call print_sources(inode(i)) 
	call getValue(inode(i),"NAME")
	if (gotValue){
		call print_sources(gottenNode) 
	}

	call print_titres(i)
	/* remember the value so it doesn't affect spousevitals */
	set(save_force_chart,force_desc_chart)
	set(force_desc_chart,0)

	set(dad, father(i))
	set(mom, mother(i))
	if (and(name_parents, or(dad, mom))) {
		", "
		/* suppression de l'article 15/11/2007 */
		if (male(i))       { "fils de " }
		elsif (female(i)) { "fille de " }
		else               { "enfant de " }
		if (dad) {
			call texname(dad, inode(dad), 0) 
			if (lookup(stab, key(dad))){
				"~({\\bf " d(lookup(stab, key(dad))) "})"
			}
		}
		if (and(dad, mom)) { "\net " }
		if (mom) {
			call texname(mom, inode(mom), 0) 
			if (lookup(stab, key(mom))){
				"~({\\bf " d(lookup(stab, key(mom))) "})"
			}
		}
		",\n"
	}

	set(name_found, 0)
	set (needname,0)
	set (canUseAnd,1)
	set (printedOne,1) /* at the start, we have just printed his fullname*/
	set (pronoun," ")
	set (anythingprinted,0)
	set (putPeriod,0)
	/* there is a mistake in this for right now, if we don't have any
	   pre-marriage info, it'll be ugly for the death.*/
	fornodes (inode(i), n) {
		if (not(printedOne)){
			if (needname){
				call printfirstname(i)
				set(pronoun,namereturn)
				set (needname,0)
				set (canUseAnd,1)
				set (printedOne,1)
				set (putPeriod,0)
				set (pronoun," ")
			}
			else {
				if (canUseAnd) {
					set (pronoun," et ")
					set (canUseAnd,0)
					set (printedOne,1)
					set (putPeriod,1)
				}
				else { /* set up for "He" this time, "and" next time. */
					/* put the period in for the first time */
					if (not(anythingprinted)) {  set (putPeriod,1)}
					else { set (putPeriod,0)}

					set (pronoun,pn (i,0))
					set (canUseAnd,1)
					set (printedOne,1)
				}
			}
			set (anythingprinted,1)
		}/* end if not printedone */
		if (or(eq(strcmp(tag(n), "ADOP"), 0),
					or(eq(strcmp(tag(n), "BAPL"), 0),
						or(eq(strcmp(tag(n), "BAPM"), 0),
							or(eq(strcmp(tag(n), "BARM"), 0),
								or(eq(strcmp(tag(n), "BASM"), 0),
									or(eq(strcmp(tag(n), "BIRT"), 0),
										or(eq(strcmp(tag(n), "BLES"), 0),
											or(eq(strcmp(tag(n), "CONF"), 0),
												or(eq(strcmp(tag(n), "CONL"), 0),
													or(eq(strcmp(tag(n), "ORDN"), 0),
														eq(strcmp(tag(n), "CHR"), 0)
													  ))))))))))){
			pronoun set(printedOne,0)
			call process_event(n, sex(i))
			if (putPeriod) {". "}
		}
		if (eq(strcmp(tag(n), "GRAD"), 0)) {
			pronoun set(printedOne,0) 
			" graduated from "
			call valuec(n)
			call process_event(n, sex(i))
			if (putPeriod) {". "}
		}

		if (eq(strcmp(tag(n), "CAST"), 0)) {
			pronoun set(printedOne,0) 
			" was a member of Caste: " call valuec(n) 
			call process_event(n, sex(i))
			if (putPeriod) {". "}
		}
		if (eq(strcmp(tag(n), "NAME"), 0)) {
			if (eq(name_found, 0)) {
				set(name_found, 1)
			} else {
				pronoun set(printedOne,0) 
				" était aussi appelé(e) " call texname(i, n, 3)
				call print_notes(n, " ") 
				call print_sources(n) 
				if (putPeriod) {". "} "\n"
			}
		}
		if (eq(strcmp(tag(n), "NAMR"), 0)) {
			pronoun set(printedOne,0) 
			"  " call valuec(n)
			call process_event(n, sex(i))
			if (putPeriod) {". "}
		}
		if (eq(strcmp(tag(n), "RELI"), 0)) {
			pronoun set(printedOne,0) 
			" était appelé(e) " call valuec(n) " en religion "
			call process_event(n, sex(i))			
			if (putPeriod) {". "}
		}
		/*                if (eq(strcmp(tag(n), "TITL"), 0)) {
						  pronoun set(printedOne,0) 
						  " portait le titre de " value(n)
						  call print_sources(n) 
						  if (putPeriod) {". "} "\n"
						  }*/
	}

	if (and(putPeriod,anythingprinted))  {". "}
	set(inhibit_text_charts,0)
	if (eq(1, nfamilies(i))) {
		families(i, f, s, n) {
			if (s){
				if (anythingprinted) {pn (i,0) }
				set(anythingprinted,1)
				call illegit_check(f)
				if (not_married_flag){
					" a eu une relation avec "
				}
				else { " a épousé " }
				/* it is OK to assume they had children if the
				   Not married flag is raised. Cuz if they
				   weren't married and didn't have kids, there
				   isn't much point in the family existing
				   (as far as this program is concerned). */
				call print_sources(fnode(f))
				call spousevitals(s, f)
			}
		}
	} else {
		set(cptspou, 0)
		families(i, f, s, nspou) {
			incr(cptspou)
			if (anythingprinted) {
				/* print "he" (or "she") for first marriage, and his
				   first name for all later marriages */
				if (gt(cptspou, 1)){
					call printfirstname(i)
					namereturn
				}
				else {pn (i,0) }      
			}
			set(anythingprinted,1)
			if (s){
				call illegit_check(f)
				if (not_married_flag){
					/*
					" a eu un(des) enfant(s) avec "
					*/
					" a eu une postérité d'une relation avec "
				}
				/*
				else{ " a épousé en " }
				ord(cptspou)
				*/
				else{ " a épousé " }
				call print_sources(fnode(f))
				call spousevitals(s, f)
				/* make sure we don't print this (i) persons
				   text and charts a second time. The theory here
				   being that if the spouse is in the stab,
				   then this person (i) has already had their
				   notes/charts done as part of their spouse.
				   We don't want to print a 2nd time */
				if (not(ancestormode)){
					if (lookup(stab, key(s))){
						set(inhibit_text_charts,1)
					}
				}
			}
			else{
				" " ord(cptspou) " a eu un enfant avec une épouse inconnue.  "
			}
		}
	}
	"  "
	/*	if (anythingprinted){
		call getText(inode(i),0)
		}*/
	/* otherwise hold off on getText until after the death info & all */
	/* I changed my mind. I like getText at the end. */
	set (needname,1)
	set (canUseAnd,0)
	set (putPeriod,0)
	if (anythingprinted){
		set (printedOne,0) /* haven't printed a name here after the spouse info */
		/* this works because pronoun is still a blank */
	}
	else{
		set (printedOne,1) /* we still have his name from way at the start */
		set (putPeriod,1) /* JUST ADDED THIS LINE 5/24/96. Don't know if works */
		/* test it on Galbraith kids where know only death.*/
	}
	fornodes (inode(i), n) {
		if (not(printedOne)){
			if (needname){
				call printfirstname(i)
				set(pronoun,namereturn)
				set (needname,0)
				set (canUseAnd,1)
				set (printedOne,1)
				set (putPeriod,0)
			}
			else {
				if (canUseAnd) {
					set (pronoun," et ")
					set (canUseAnd,0)
					set (printedOne,1)
					set (putPeriod,1)
				}
				else {
					set (pronoun,pn (i,0))
					set (canUseAnd,1)
					set (printedOne,1)
					set (putPeriod,0)
				}
			}
		}
		if (or(eq(strcmp(tag(n), "BURI"), 0),
					or (eq(strcmp(tag(n), "CREM"), 0),
						or (eq(strcmp(tag(n), "CENS"), 0),
							or (eq(strcmp(tag(n), "CHRA"), 0),
								or (eq(strcmp(tag(n), "DEAT"), 0),
									or (eq(strcmp(tag(n), "NATU"), 0),
										or (eq(strcmp(tag(n), "RETI"), 0),
											or (eq(strcmp(tag(n), "RESI"), 0),
												or (eq(strcmp(tag(n), "PROB"), 0),
													or (eq(strcmp(tag(n), "LIVD"),0),
														eq(strcmp(tag(n), "WILL"), 0)
													   ))))))))))){
			/* pronoun set(printedOne,0) */
			/* Ne pas traiter les DEAT Y (sans date ni lieu) */
			if(eqstr(tag(n), "DEAT")) {
				if(or(date(n),place(n))) {
					pronoun set(printedOne, 0)
					call process_event(n, sex(i))
				}
			}
			else {
				pronoun set(printedOne, 0)
				call process_event(n, sex(i))
			}
			if (putPeriod) {". "}
		}
		/* One part of the GEDCOM standard says the tag should be DSCR,
		   another part says DESR. */
		if (eq(strcmp(tag(n), "DESR"), 0)) {
			pronoun set(printedOne,0) 
			"Description: " call valuec(n)
			call print_sources(n) 
			if (putPeriod) {". "}
		}
		if(traitEven) {
			if (eq(strcmp(tag(n), "EVEN"), 0)) {
				pronoun set(printedOne,0) 
				value(n)
				call process_event(n, sex(i))
				if (putPeriod) {". "}
			}
		} /* De if(traitEven) */
		if (eq(strcmp(tag(n), "OCCU"), 0)) {
			pronoun set(printedOne,0)
			/* should also check for a RETIred node
			   and always say WAS if it exists */
			/* DAB - replace with do_occu; delete this when do_occu accepted
			   call getValue(inode(i),"RETI")
			   if (gotValue){ " was"}
			   else { call iswas(i)}
			   " "
			   call valuec(n)
			   call process_event(n, sex(i))
			 */
			call do_occu(n, i)
			if (putPeriod) {". "}
		}
		if (eq(strcmp(tag(n), "PROP"), 0)) {
			pronoun set(printedOne,0) 
			" possédait : " call valuec(n) "."
			call print_sources(n) 
			if (putPeriod) {". "}
		}
	}
	if (putPeriod) {". "}
	/* restore forcing of desc. charts */
	set(force_desc_chart,save_force_chart)
	if (not(inhibit_text_charts)){
		call getText(inode(i),0)
		call process_book_notes (i)
	}
	set(global_dead,local_dead) /* restore */
}

/* isRange(d) - Indicate if a date node is a range
 * 
 * d - DATE node (could be NIL)
 *
 * Returns: 1 if <d> is of the form "[BET] date1-date2"; 0 otgherwise
 *
 */

func isRange(d)
{
    set(r, 0)
    if (d) {
    	if (i, index (d, "-", 1)) { 
    	    set(r, 1)
    	} elsif (i, index (d, "FROM", 1)) { 
    	    set(r, 1)
	}
    }
    return(r)
}

/* do_occu(n, i) - Process an OCCU node
 * 
 * n - OCCU node
 * i - INDI containing <n>
 *
 * An OCCU node will produce text saying "<name> is/was a <occu> with <agnc> ...."
 * It is assumed that the <name> was printed before this routine was called.
 * If the person is (likely) deceased, if the OCCU node has a subordinate RETI node,
 * or if the DATE tag subordinate to the OCCU node is a range, then "was" is used in
 * the sentence; otherwise, "is" is used. The "with <agnc>" clause is added if a
 * AGNC node is subordinate to the OCCU node; it is taken to be the name of the 
 * employer.
 *
 */

proc do_occu(n, i)
{
	/* Check for date range or RETI node and use "was" if either present. */
	set(d, date(n))
	call getValue(inode(i), "RETI")
	if (or(gotValue, isRange(d))) {
		" était"
	} else
	{
		call iswas(i)
	}
	" "
	call valuec(n)
	call getValue(n, "AGNC")
	if (gotValue) {
		" with " gottenValue
	}
	call process_event(n, sex(i))
}

/* spousevitals (spouse, fam)
   Prints out information about a marriage (fam) and about a spouse in the
   marriage (spouse). */

proc spousevitals (spouse, fam)
{
	set(npfx, get_npfx(spouse))
	if(nestr(npfx, "")) {
		if(eqstr(sex(spouse), "F")) {
			" la "
		}
		else {
			" le "
		}
		npfx " "
	}
	call texname(spouse, inode(spouse), 3)

	if (spouse){
		call print_sources(inode(spouse))
		call getValue(inode(spouse),"NAME")
		if (gotValue){
			call print_sources(gottenNode) 
		}
	}

	if (e, marriage(fam)) {
		call process_event(e, sex(spouse)) 
	}
	". " 
	call check_print_divinfo(fam)
	call check_print_marcinfo(fam)
	call check_print_livdinfo(fam)

	if (spouse) {
		set(bir, birth(spouse))
		set(chr, baptism(spouse))
		set(dea, death(spouse))
		set(bur, burial(spouse))
		set(dad, father(spouse))
		set(mom, mother(spouse))
		set(sexe, sex(spouse))

		if(dea) {
			set(prdea, or(place(dea),date(dea)))}
		else {
			set(prdea, 0)
		}
		set(local_dead,global_dead) /* save for restore */
		set(global_dead,dea)

		if (or(or(or(or(or(bir, chr), prdea), bur), mom), dad)) {
			call printfirstname(spouse)
			namereturn
			if (or(mom, dad)) {
				", "
				/* suppression de l'article le 15/11/2008 */
				if    (male  (spouse)) { "fils de " }
				elsif (female(spouse)) { "fille de " }
				else                   { "enfant de " }
				if (dad)               { 
					call texname(dad, inode(dad), 3) 
					if (lookup(stab, key(dad))){
						"~({\\bf " d(lookup(stab, key(dad))) "})"
					}
				}
				if (and(mom, dad))     { " et " }
				if (mom)               { 
					call texname(mom, inode(mom), 3) 
					if (lookup(stab, key(mom))){
						"~({\\bf " d(lookup(stab, key(mom))) "})"
					}

					", "
				}
			}

			if (or(or(or(bir, chr), prdea), bur)) {
				if (bir) {
					call vitalEvent(bir, 1, sexe)
					call print_sources(bir)
					if (chr) {
						" et"
						call vitalEvent(chr, 0, sexe)
						call print_sources(chr)
						". "
					}
					if (prdea){
						if (chr){ pn(spouse,0)}
						else {" et"}
						call vitalEvent(dea, 1, sexe)
						call print_sources(dea)
						". "
					}
					else {if (not(chr)){ ". "}} /* born, but nothing more */
				}
				if (and(chr, not(bir))) {
					call vitalEvent(chr, 1, sexe)
					call print_sources(chr)
					". "
				}
				if (and(prdea,not(bir))) { /* if bir, then dea is already handled */
					if (chr) { /* then need to print pronoun, otherwise don't
								  since we still have the name standing there, 
								  not finishing a sentence */
						pn(spouse,0) 
					} 
					call vitalEvent(dea, 1, sexe)
					call print_sources(dea)
					". "
				}
				if (bur) {
					if (or(or(bir,prdea),chr)){ pn(spouse,0)}
					call vitalEvent(bur, 0, sexe)
					call print_sources(bur)
					".\n"
				}
			}
		}
		if (gt(nfamilies(spouse),1)) {
			set(beforefam,1)
			families(spouse, newfam, newspouse, n) {
				if(ne(newfam,fam)){
					call printfirstname(spouse)
					namereturn
					if (beforefam){
						" a "
						/* if (gt(n,1)){"also "} */
						"épousé précédemmment "
					}
					else {
						if (eqstr(sexe, "F")) {
							" s'est ensuite remariée avec"
						}
						else {
							" s'est ensuite remarié avec"
						}
					}
					if (newspouse){
						call texname(newspouse, inode(newspouse), 3)
					}
					set(e,marriage(newfam))
					if (e){ call process_event(e, sex(spouse)) }
					if (gt(nchildren(newfam),0)){
						", et a eu "
						d(nchildren(newfam))
						if (gt(nchildren(newfam),1)){
							" enfants "
						}
						else { " enfant"}
						" de ce mariage : "
						children(newfam,stepchild,numerical){
							if (gt(numerical,1)){ ", "}
							call printfirstname(stepchild)
							namereturn
						}				
					}

					". "
				}
				else { set(beforefam,0)} /* we see the current family */
			}
		}
		if (not(lookup(stab, key(spouse)))){ /* don't print a 2nd time */
			call getValue(inode(spouse),"OCCU")
			if (gotValue){
				set (savenode,gottenNode)
				call printfirstname(spouse)
				namereturn

				/* should also check for a RETIred node
				   and always say WAS if it exists */
				/* DAB - replace with do_occu; delete this when do_occu is accepted
				   call getValue(inode(spouse),"RETI")
				   if (gotValue){ " was"}
				   else { call iswas(spouse)}
				   " "
				   call valuec(savenode)
				   call process_event(savenode)
				   ". "
				 */
				call do_occu(savenode, spouse) ". "
			}
			call getText(inode(spouse),0)
			call process_book_notes (spouse)
		}

		set(global_dead,local_dead) /* restore */

	} else {
		"\\noname" ".\n"
	}  
}


/* texname (i, type)
   Prints an individual's name in LaTeX format, with the surname in small caps.
   For example, "David Kenneth /Olsen/ Jr." would be printed as
   "David Kenneth {\sc Olsen} Jr.".  The type argument determines how the name
   will appear in the index.
        type = 0: no index
        type = 1: page number appears in bold
        type = 2: page number appears in bold-italics
        type = 3: page number appears in normal text
   The parameter i can be either an INDI node (NOT an individual) or a
   NAME node. */

proc texname (indiv, i, type)
{
	list(name_list)

	set(sname, "")
	extractnames(i, name_list, num_names, surname_no)
	forlist (name_list, nm, num) {
		if (eq(num, surname_no)) {
			if (eq(strcmp(nm, ""), 0)) {
				" \\noname"
				set(sname, "\\noname")
			} else {
				if (eq(strcmp(nm, "____"), 0)) {
					set(sname, "\\noname")
				}
				else {
					" {\\sc " nm "}"
					set(sname, nm)
				}
			}
		} else {
			" " nm
		}
	}
	if (gt(type, 0)) {
		"\\index{" sname
		if (gt(num_names, 1)) { "," }
		forlist (name_list, nm, num) {
			if (ne(num, surname_no)) {
				" " nm
			}
		}
		set (indexdates, " (")
		if (year(birth(indiv))) {
			set(indexdates, strconcat(indexdates, year(birth(indiv))))
		}
		else {
			if (year(baptism(indiv))) {
				set(indexdates, strconcat(indexdates, year(baptism(indiv))))
			}
		}
		set(indexdates, concat(indexdates, "-"))
		if (year(death(indiv))) {
			set(indexdates, strconcat(indexdates, year(death(indiv))))
		}
		else {
			if (year(burial(indiv))) {
				set(indexdates, strconcat(indexdates, year(burial(indiv))))
			}
		}
		set(indexdates, concat(indexdates, ")"))
		if (nestr(indexdates, " (-)")) { indexdates }
		if    (eq(type, 1)) { "|bold"}
		elsif (eq(type, 2)) { "|bfit"}
		"}"
	}
}

proc print_titres(indiv)
{
	set(femin, 0)
	set(nbtitr, 0)
	set(afftitr, "")
	if(eqstr(sex(indiv), "F")) {
		set(femin, 1)
	}
	fornodes(inode(indiv), noeud) {
		if(eqstr(tag(noeud), "TITL")) {
			set(afftitr, formatgw(noeud, femin))
			", " afftitr
			if(datetitl, date(noeud)) {
				" (" complexdate(datetitl) ")"
			}
		}
	}
}

/* process_event (event_node, event_name)
   Prints information about a particular event (event_node, which is a GEDCOM
   node).  event_name is verb form of the text describing the event (such as
   "Born", "Died", etc.). */

proc process_event (event_node, sexe)
{
	call vitalEvent(event_node, 0, sexe)
	call print_sources(event_node)
	call print_notes(event_node, " ") 
}

proc inPlace (event)
{
	if (place (event)) {
		if (eq(strcmp(place(event),""),0)) {
			" à \\noname"
		} else {

			call atAddr (event)
			if (not (strcmp(atAddrValue,""))){ set(fullSpecCompare,1)}
			else { set(fullSpecCompare,2)}/* there was an ADDR. We want to 
											 say at X in Y */
			list (placeList)
			list (placeTextList)
			list (placeTagList)
			list (listelieu)
			extracttokens(decoup_plac(event, decpl, optpl), placeList, nPlaces, ",")

			requeue (placeList, atAddrValue)
			while (placeText, dequeue (placeList)) {
				enqueue (placeTextList, placeText)
				set (placeTag, placeText)
				forlist (placeList, place, placeN) {
					set (placeTag, concat (placeTag, concat ("-", place)))
				}
				enqueue (placeTagList, placeTag)
			}

			set (there, getel (placeTagList, 1))
			if (not (strcmp (there, lookup (eventPlaceTable, "@there@")))) {
				"\nau même lieu"
			} else {
				insert (eventPlaceTable, "@there@", there)
				set (fullySpecified, 0)
				forlist (placeTextList, place, placeN) {
					set (placeTag, dequeue (placeTagList))
					if (not (eq(fullySpecified,fullSpecCompare))) {
						if (eq (placeN, 2)) {
							/* if the name of the place doesn't start with "near", say "in" */
							if (and(strcmp (substring (place,1,4), "vers"),
										and (strcmp (substring (place,1,1), "à"),
											and (strcmp (substring (place,1,2), "au"),
												and (strcmp (substring (place,1,5), "north"),
													and (strcmp (substring (place,1,4), "west"),
														and (strcmp (substring (place,1,4), "from"),
															strcmp (substring (place,1,4), "east"))))))))

								/* note that case matters a lot in that comparison */
								/* a town might be named North English, but one should
								   always have written, "north of English" if
								   you just want to say it is outside of town */
							{ "\nà " }
							else {
								if (not(strcmp (substring (place,1,4), "from"))){" et était\n"}
								/* Actually, that isn't quite what I want because if
								   it has someone b. PLAC from there but no date, it'll wind
								   up outputting "He was born and was from there". But oh well. */
								else{"\n"} /* put nothing there if it says "near" */
							}
						}
						elsif (gt (placeN, 2)) { ", " }
						/* au lieu de place */
						place
						if (strlen (place)) {
							if (not (lookup (eventPlaceTable, placeTag))) {
								insert (eventPlaceTable, placeTag, 1)
								/* this next fiddling with fullSpecCompare is because
								   the FIRST time we see an "at ADDR in a,b,c"
								   since ADDR-a-b-c isn't in the table, it would
								   try to print "at ADDR in a,b". We just want it to 
								   print "at ADDR in a" if a,b,c was previously defined. */
								set(fullSpecCompare,1)
							} else {
								set (fullySpecified, add(fullySpecified,1))
							}
							if (gt(index(place,"Twp",1),0)) { /* then it is just the name
																 of a township, which I don't think is much
																 use without the county name, so I'm always
																 going to force it to print the county name
																 if it gives a township */
								set(fullSpecCompare,add(1,fullSpecCompare))
							}
						}
					}/* end if not fullySpecified */
				}
			}
		}/* matches the else for place being non-null */
	}
}
/* Possible customization I have chosen not to implement:
	Suggested by: "John F. Chandler"   <JCHBN@CUVMB.CC.COLUMBIA.EDU>
 	if(gt(nPlaces,1)) { set(inWord,"at") }
	 else { set(inWord,"in") }
	 if(not(strcmp(tag(event),"IMMI"))) { set(inWord,"to") }
	 if(not(strcmp(tag(event),"GRAD"))) {
	   if(eq(nPlaces,1)) { set(inWord,"from") }
	   else { set(inWord,"-") }
	 }
	 inWord " "
	instead of the original "in ".  This assumes that the institution is
	recorded in the PLAC
   I (DN) Think there is a little more to it than that because of the way
   I currently use atAddr, but I'm sure you can figure all that out.
   I currently assume that the institution name is the value of the
   1 GRAD line, e.g. 1 GRAD Univ. of Iowa and I handle it as a special case.
*/	


proc atAddr (root)
{
	set (atAddrValue, "")
	if (root) {
		fornodes (root, node) {
			if (not (strcmp (tag (node), "PLAC"))) {
				fornodes (node, subnode) {
					if (and (not (strcmp (atAddrValue, "")),
								or (not (strcmp (tag (subnode), "ADDR")),
									not (strcmp (tag (subnode), "CEME"))))) {
						if (val, value (subnode)) {
							set (atAddrValue, concat ("\nà ", val))
						}
					}
				}
			}
		}
	}
}
proc check_print_divinfo(fam)
{
	call getValue (fnode(fam), "DIV")
	if (gotValue) {
		" Ils ont divorcé"
		call process_event(gottenNode, "M")
		".  "
	}

}
proc check_print_marcinfo(fam)
{
	call getValue (fnode(fam), "MARC")
	if (gotValue) {
		" Ils ont établi un contrat de mariage"
		call process_event(gottenNode, "M")
		".  "
	}
}
proc check_print_livdinfo(fam)
{
	call getValue (fnode(fam), "_RESI")
	if (gotValue) {
		" Ils "
		call process_event(gottenNode, "P")
		".  "
	}
}

/* print_notes (root, sep):  Prints all the notes (NOTE nodes) associated with
   the GEDCOM line root, separated by the given separator. */

proc print_notes (root, sep)
{
	set(pn_cpt, 0)
	fornotes (root, note) {
		incr(pn_cpt)
		if(and(eq(pn_cpt, 1), notes_pied)) {
			"\\footnote{" note
		}
		else {
			sep note /* " "*/
		}
	}
	if(and(pn_cpt, notes_pied)) {
		"}"
	}
}

global(pedigreeFigureLabel)

proc process_book_notes (indi)
{
	set(hadpednote,0)
	set(haddescnote,0)
	set(doexcursion,0)

	if(lookup(tabance, key(indi))){
		set(hadpednote, 1)
	}
	if(lookup(tabdesc, key(indi))){
		set(haddescnote, 1)
	}
	if(lookup(tabexcu, key(indi))){
		set(doexcursion, 1)
	}
	fornodes(inode(indi), n) {
		if(eqstr(tag(n),"_BOOKPEDIGREE")) {set(hadpednote, 1)}
		if(eqstr(tag(n),"_BOOKDESCENDENT")) {set(haddescnote, 1)}
		if(eqstr(tag(n),"_BOOKEXCURSION")) {set(doexcursion, 1)}	
		if(eqstr(tag(n),"_BOOKCHAPSLIT")) {set(hadsplitnote, 1)}	
	}
	if (eq(hadpednote,1)){
		call pedigreeFigure (indi)
		if (strcmp (pedigreeFigureLabel, "")) {
			pn (indi, 2)
			" ascendance est illustrée figure \\protect\\ref{" 
			pedigreeFigureLabel "}."
		}
	}
	if (force_desc_chart) {
		set(haddescnote,1)
	}
	if (eq(haddescnote,1)){
		set (descFigureLabel, concat (key (indi), "-figure-desc"))
		"\nUn arbre descendant de "
		call texname(indi, inode(indi), 3)
		" est donné "
		"figure~\\ref{"   descFigureLabel   "}."
		"\n\\begin{figure*}\n"
		"\\centering\n"
		call desc_chart_main3(indi)
		"\n\\caption{Descendants de " name(indi) "~({\\bf "
		d(lookup(stab, key(indi))) "})}" nl()
		"\\label{" descFigureLabel "}"
		"\\end{figure*}\n"
	}
	if (eq(0,ancestormode)){
		if (eq(doexcursion,1)){
			pn (indi, 2) " ascendance agnatique est étudiée en détail page ~\\pageref{"
			key(indi) "-excur-ref}" 
			" dans ce chapître.\n\n"
			enqueue(excurlist,indi)
		}
	}
}
proc pedigreeFigure (i)
{
	indiset (iSet)
	addtoset (iSet, i, 1)
	set (max, 0)
	indiset (extraSet)
	set(extraSet,ancestorset (iSet))
	forindiset (extraSet, indi, val, num) {
		if (gt (val, max)) {
			set (max, val)
		}
	}
	if (gt (max, 1)) {
		set (pedigreeFigureLabel, concat (key (i), "-figure-pedigree"))
		if (gt (max, 5)) { set (max, 5) }
		call figPed (max, i)
	} else {
		set (pedigreeFigureLabel, "")
	}
}

proc figPed (n, indi)
{
	"\n\\begin{figure*}"
	"\n\\centering"
	"\n\\small"
	"\n\\setlength{\\unitlength}{"
	if (eq (n, 5)) { ".8" } else { ".9" }
	"\n\\baselineskip}"

	call pow (2, n)
	"\n\\begin{picture}(" d (add (mul (6, n), 12)) 
	"," d (sub (mul (powValue, 2), 1)) ")(0,.5)"

	call ped6 (indi, 0, powValue, powValue) 

	"\n\\end{picture}"
	"\n\\caption{Ancêtres de " call scname (indi) "}"
	"\n\\label{" pedigreeFigureLabel "}"
	"\n\\end{figure*}" 
}

proc ped6 (indi, x, y, z)
{
	"\n\\put(" d(mul (x, 6)) "," d(y) "){\\makebox(0,0)[l]{" call scname (indi) 
	"}}"
	if (x) {
		"\n\\put(" d (sub (mul (x, 6), 3)) "," d(y) "){\\line(1,0){" d(3) "}}"
		"\n\\put(" d (sub (mul (x, 6), 3)) "," d(y) "){\\line(0,"
		if (female (indi)) { "1" } else { "-1" }
		"){" d (sub (z, 1)) ".4}}"
	}
	if (z2, div (z, 2)) {
		if (f, father (indi)) { call ped6 (f, add (x, 1), add (y, z2), z2) }
		if (m, mother (indi)) { call ped6 (m, add (x, 1), sub (y, z2), z2) }
	}
}

proc scname (indi)
{
	fullname(indi,0,1,99)
	if (lookup(stab, key(indi))){
		"~({\\bf " d( lookup(stab, key(indi))) "})"
	}
}

proc pow (x, i) { set (powValue, 1) call powIt (x, i) }

proc powIt (x, i)
{ 
	if (i) {
		set (powValue, mul (powValue, x))
		call powIt (x, sub (i, 1))
	}
}


/* print_sources (root)
   Prints all sources (SOUR lines) associated with the given GEDCOM line.  The
   sources are formated as LaTeX footnotes.  This routine prints each SOUR line
   as a separate footnote, which is not correct.  This should be corrected so
   that all sources are combined into a single footnote. */

proc print_sources (root)
{
	enqueue(sourceList,root)
	call sourceIt(sourceList)
}


/* valuec(n):  Prints the value of a GEDCOM node and the values of any CONT
   lines associated with it. */

proc valuec(n)
{
	value(n)
	fornodes (n, n1) {
		if (eq(strcmp(tag(n1), "CONT"), 0)) {
			"\\\\\n" value(n1)
		} elsif (eq(strcmp(tag(n1), "CONC"), 0)) {
			value(n1)
		}
	}
}
proc resetdayplace()
{
    call setDayNumber (0)
    insert (eventPlaceTable, "@there@", "")
}

proc vitalEvent (event, reset, sexe) {
	if (reset) {
		call setDayNumber (0)
		insert (eventPlaceTable, "@there@", "")
	}
	if (event) {
		if(eqstr(sexe, "F")) {
			if (eventName, lookup (eventNameTableF, tag (event))) {
				" " eventName
				if (or (not (strcmp (tag (event), "ADOP")), 
				or (not (strcmp (tag (event), "CHR")), 
				or (not (strcmp (tag (event), "CREM")), 
				not (strcmp (tag (event), "BURI")))))) {
					set (previousDayNumber, dayNumber)
				} else {
					set (previousDayNumber, 0)
				}
			}
		}
		elsif(eqstr(sexe, "P")) { /* Pluriel */
			if (eventName, lookup (eventNameTableP, tag (event))) {
				" " eventName
				set (previousDayNumber, dayNumber)
			}
		}
		else {
			if (eventName, lookup (eventNameTable, tag (event))) {
				" " eventName
				if (or (not (strcmp (tag (event), "ADOP")), 
				or (not (strcmp (tag (event), "CHR")), 
				or (not (strcmp (tag (event), "CREM")), 
				not (strcmp (tag (event), "BURI")))))) {
					set (previousDayNumber, dayNumber)
				} else {
					set (previousDayNumber, 0)
				}
			}
		}
		if (not (eventName)) {
			call getValue(event, "TYPE")
			if (gotValue) {
				" " gottenValue
			}
    	}
    	if (not (strcmp (tag (event), "DEAT"))) {
			call ofCause (event)
    	}
		call onDate (event)
		call atAge (event)

		call inPlace (event)
	}
}

proc setDayNumber (event)
{
	set (dayNumber, 0)
	if (date (event)) {
		extractdate (event, day, month, year)
		/* DAB - Have to check day month and year, otherwise two events for which only the year is known
		 * are said to have occurred on "the same day"
		 */
		if (and(and(year, month), day)) {
			set(dayNumber, date2jd(event) )
		}
	}
}

proc atAge (event)
{
	call getValueCont (event, "AGE")
	if (gotValue) {
		if (not(strcmp(gottenValue, "CHILD"))) { "\njeune" }
		elsif(not(strcmp(gottenValue, "STILLBORN"))) { "\nmort-né" }
		elsif(not(strcmp (gottenValue, "INFANT"))) { "\nenfant" }
		else { "\nà l'âge de " gottenValue }
	}
}
proc ofCause (event) {
	call getValueCont (event, "CAUS")
	if (gotValue) {
		"\n (" gottenValue ") "
	}
}
proc onDate (event)
{
	if (atmax_generation) {
		if (global_dead) {
			set(year_only,0)
		}
		else {
			set(year_only,1)
		}
	}
	else {
		set(year_only,0)	
	}

	call setDayNumber (event)
	if (d, date (event)) {
		/* TODO : Not married dans DATE ??? */
		if (strcmp (d, "Not married")) {
			/* Modif Guy Gentil \nle au lieu de \nin  */
			if (eq(strcmp(d, ""),0)) { "\nle \\nodate\\ " } 
			elsif (eq (index (d, "AFT", 1), 1)) { "\naprès " }
			elsif (eq (index (d, "BEF", 1), 1)) { "\navant " }
			elsif (eq (index (d, "ABT", 1), 1)) { "\nvers " }
			elsif (eq (index (d, "FROM", 1), 1)) { 
				set(t, index(d, "TO", 1))
				/* DAB - experimental (and not working) 
				   set(fromDateEvent, createnode("EVEN", ""))
				   set(fromDateNode, createnode("DATE", substring (d, add(1, strlen("FROM")), sub (t, 1)) ))
				   addnode(fromDateNode, fromDateEvent, 0)
				   set(toDateEvent, createnode("EVEN", ""))
				   set(toDateNode, createnode("DATE", substring (d, add (t, strlen("TO")), strlen (d)) ))
				   addnode(toDateNode, toDateEvent, 0)
				   DEBUG:
				   "\n from date nodes: " traverse(fromDateEvent, xx, yy) {
				   d(yy) ": " tag(xx) " " value(xx)
				   }
				   "\n to date nodes: " traverse(toDateEvent, xx, yy) {
				   d(yy) ": " tag(xx) " " value(xx)
				   }

				   "\nfrom " stddate(fromDateEvent)
				   " to " stddate(toDateEvent)
				   deletenode(toDateNode)
				   deletenode(toDateEvent)
				   deletenode(fromDateNode)
				   deletenode(fromDateEvent)
				   DAB - end of experimental */
				/* DAB - This way works, but doesn't necessarily produce dates in the same format as stddate */
				"\nde " substring (d, add(1, strlen("FROM")), sub (t, 1)) 
				" à " substring (d, add (t, strlen("TO")), strlen (d)) 
				/**/
				set (event, 0)
			} elsif (i, index (d, "-", 1)) { 
				"\nentre " substring (d, 1, sub (i, 1)) 
				" et " substring (d, add (i, 1), strlen (d)) 
				set (event, 0)
			} elsif (and (dayNumber, eq (dayNumber, previousDayNumber))) {
				"\nle même jour"
				set (event, 0)
			} elsif (and (dayNumber, eq (dayNumber, add (previousDayNumber, 1)))) {
				"\nle lendemain"
				set (event, 0)
			} elsif (and (dayNumber, eq (dayNumber, add (previousDayNumber, 2)))) {
				"\ndeux jours après"
				set (event, 0)
			} elsif (and (dayNumber, eq (dayNumber, add (previousDayNumber, 7)))) {
				"\nune semaine après"
				set (event, 0)
			} else {
				if (year_only){ "\nen " }
				else {
					extractdate (event, d, m, y)
					if (d) { "\nle " } else { "\nen " }
				}
			}
			if (event) { 
				if (and (dayNumber, eq (dayNumber, previousDayNumber))) {
					"ce jour"
				} else {
					if (year_only){
						year (event) 
					}
					else {
						/* TODO : avant stddate(date(event)) */
						set(dgreg, date(event))
						set(drep, tocalrep(dgreg, place(dgrep)))
						stddate (dgreg)
						if(nestr(dgreg, drep)) {
							" (" stddate(drep) ")"
						}
					}
				}
			}
		}
	}
}
proc getValue (root, t)
{
	set (gotValue, 0)
	if (root) {
		fornodes (root, node) {
			if (and (not (gotValue), not (strcmp (tag (node), t)))) {
				set (gotValue, 1)
				set (gottenNode, node)
				set (gottenValue, value (node))
			}
		}
	}
}

proc getValueCont (root, t)
{
	set (gotValue, 0)
	if (root) {
		fornodes (root, node) {
			if (and (not (gotValue), not (strcmp (tag (node), t)))) {
				set (gotValue, 1)
				set (gottenNode, node)
				set (gottenValue, value (node))
				fornodes (node, subnode) {
					if (not (strcmp ("CONT", tag (subnode)))) {
						/* If you want empty CONT tags to not leave a blank line, uncomment the following "if".
						 * However, a blank line can be very useful (or even necessary) for some TeX formatting.
						 */
						/*if (strlen (value (subnode))) */
						set (gottenValue, 
								concat (gottenValue, concat ("\\\\\n", value (subnode))))
						/*}*/
					} elsif (not (strcmp ("CONC", tag (subnode)))) {
						/* Same comment as above, this time for CONC tags */
						/*if (strlen (value (subnode))) {*/
						set (gottenValue, concat (gottenValue, value (subnode)))
						/*}*/
					}
				}
			}
		}
	}
}

proc getValueCommaCont (root, t)
{
	set (gotValue, 0)
	if (root) {
		fornodes (root, node) {
			if (and (not (gotValue), not (strcmp (tag (node), t)))) {
				set (gotValue, 1)
				set (gottenNode, node)
				set (gottenValue, value (node))
				fornodes (node, subnode) {
					if (not (strcmp ("CONT", tag (subnode)))) {
						if (strlen (value (subnode))) {
							set (gottenValue, concat (gottenValue, concat (",\\\\\n", value (subnode))))
						}
					} elsif (not (strcmp ("CONC", tag (subnode)))) {
						if (strlen (value (subnode))) {
							set (gottenValue, concat (gottenValue, value (subnode)))
						}
					}
				}
			}
		}
	}
}

proc printfirstname(i)
{
	set(firstname,givens(i))
	if (eq(strcmp(firstname,""), 0)) {
		set(namereturn,"\\noname")
	} else {
		set (where,index(firstname," ",1))
		/* don't print out middle names */
		if (gt(where,0)){
			set(namereturn,substring(firstname,1,sub(where,1)))
		}
		else {set(namereturn, firstname)} /* if no middle names */
	}
}

proc iswas (indi)
{
	call setDayNumber (birth (indi))
	if(or(death(indi), burial(indi))) {
		"\nétait" 
	} else {
		"\nest"
	}
}
/* Check to see if this family might still have children at some point:
   If one spouse is dead, too old, or they are divorced; then they won't. */
proc havehadchildren (indi, spouse) 
{
	call setDayNumber (birth (indi))
	set(indiDayNumber, dayNumber)
	call setDayNumber (birth (spouse))
	set(divp, 0)
	spouses(indi, s, f, n) {
		if (eq(s, spouse)) {
			call getValue (fnode(f), "DIV")
			set(divp, gotValue)
			break()
		}
	}
	if (or (death (indi), burial(indi), death (spouse), burial(spouse), divp)) {
		"\\ n\'ont pas eu d\'enfant.\n"
	} else {
		"\\ n\'ont pas d'enfant.\n"
	}
}
/* la version originale teste "not married" en date de mariage */
proc illegit_check (fam) {
	set(not_married_flag, 1)
	if(e, marriage(fam)) { 
		set(not_married_flag, 0)
	}
}

proc sourceIt (sourceList)
{
	list (cList)
	list (fList)
	set(cn, 0)
	while (root, dequeue (sourceList)) {
		fornodes (root, node) {
			if (not (strcmp (tag (node), "SOUR"))) {
				set (footnote, 1)
				set (val, value (node))
				if (val) {
					if (reference(val)){
						call bibliographize (dereference(val))
					}
				}
				if (xref (node)) {
					call bibliographize (node)
					set (val, xref (node))
				}
				if (val) {
					set (a1, index (val, "@", 1))
					set (a2, index (val, "@", 2))
					if (and (eq (a1, 1), eq (a2, strlen (val)))) { 
						set (c, substring (val, 2, sub (strlen (val), 1)))
						enqueue (cList, c)
						incr (cn)
						set (footnote, 0)
					}
				} else {
					set (subnodecount, 0)
					fornodes (node, subnode) {
						if (strcmp (tag (subnode), "SOUR")) {
							incr (subnodecount)
						}
					}
					if (eq (subnodecount, 0)) {
						fornodes (node, subnode) {
							set (val, value (subnode))
							/* With loadsources, this is needed here. It is technically
							   illegal gedcom. */
							/* TODO : beurk, à étudier */
							if (xref (subnode)) {
								call bibliographize (subnode)
								set (val, xref (subnode))
							}
							if (val) {
								set (a1, index (val, "@", 1))
								set (a2, index (val, "@", 2))
								if (and (eq (a1, 1), eq (a2, strlen (val)))) { 
									set (c, substring (val, 2, sub (strlen (val), 1)))
									enqueue (cList, c)
									incr (cn)
								}
							} 
						}
						set (footnote, 0)
					}
				}
				if (footnote) {
					enqueue (fList, node)
				}
			}
		}
	}
	while (cn) {
		forlist (cList, c, n) {
			if (and (ne (n, cn), not (strcmp (c, getel(cList, cn))))) {
				setel (cList, cn, "")
			}
		}
		decr (cn)
	}
	if (not (empty (fList))) {
		"\n\\footnote{" 
		while (f, dequeue (fList)) { 
			set (first, 1)
			call getValueCont (f, "TITL") 
			if (gotValue) { 
				if (not (first)) { ", " } else { set (first, 0) }
				"\n" gottenValue
			}
			call getValueCont (f, "DATE") 
			if (gotValue) { 
				if (not (first)) { ", " } else { set (first, 0) }
				"\n" gottenValue
			}
			call getValueCont (f, "PLAC") 
			if (gotValue) { 
				if (not (first)) { ", " } else { set (first, 0) }
				"\n" gottenValue
			}
			call getValueCont (f, "VOLU") 
			if (gotValue) { 
				if (not (first)) { ", " } else { set (first, 0) }
				if (or (index (gottenValue, "-", 1),
							or (index (gottenValue, ",", 1),
								index (gottenValue, "et ", 1)))) {
					"\nVolumes "
				} else {
					"\nVolume "
				}
				gottenValue
			}
			call getValueCont (f, "PAGE") 
			if (gotValue) { 
				if (not (first)) { ", " } else { set (first, 0) }
				if (or (index (gottenValue, "-", 1),
							or (index (gottenValue, ",", 1),
								index (gottenValue, "et ", 1)))) {
					"\nPages "
				} else {
					"\nPage "
				}
				gottenValue
			}
			call getValueCont (f, "FILM") 
			if (gotValue) { 
				if (not (first)) { ", " } else { set (first, 0) }
				"on Latter Day Saints Microfilm Number " 
				gottenValue
			}

			call getValueCont (f, "TEXT") 
			if (gotValue) { 
				set (first, 0)
				"\n" gottenValue
			}
			if (not (first)) { "\\@." }
			call getValueCont (f, "NOTE") 
			if (gotValue) { 
				set (first, 0)
				"\n" gottenValue
			}
			if (and (first, not (value (f)))) { "\n" }
			call values (f)
		}
		"}"
	}
	if (not (empty (cList))) {
		"~\\cite{"
		while (c, dequeue (cList)) {
			if (strlen (c)) {
				if (cn) { "," }
				c
				incr (cn)
			}
		}
		"}"
	}
}

proc bibliographize (root) 
{
	set (val, xref (root))
	set (c, substring (val, 2, sub (strlen (val), 1)))

	if (not (lookup (bibTable, c))) {
		insert (bibTable, c, 1)

		/*    call getValueCont (root, "TEXT")
			  if (figureFlag, gotValue) {
			  enqueue (figureCiteList, c)
			  enqueue (figureNodeList, gottenNode)
			  }*/
		set (cref, concat ("\\protect\\ref{", concat (c, "}")))
		set (pref, concat ("\\protect\\pageref{", concat (c, "}")))

		set (b, "\\bibitem")
		if (figureFlag) {
			set (b, concat (b, concat ("[", concat (cref, "]"))))
		}
		set (b, concat (b, concat ("{", concat (c, "} "))))
		call getValueCont (root, "AUTH") 
		if (gotValue) { 
			set (b, concat (b, concat (" ", concat (gottenValue, ", "))))
		}
		call getValueCont (root, "TITL") 
		if (gotValue) { 
			set (b, concat (b, concat ("{\\em ", concat (gottenValue, "}, "))))
		}
		/* TODO gérér ifpdf */
		call getValueCont (root, "PUBL") 
		if (gotValue) {
			if(and(eq(pdfmode, 1), eqstr(substring(gottenValue, 1, 4), "http"))) {
				set(gottenValue, concat("\\href{", gottenValue, "}{", gottenValue, "}"))
			}
			set (b, concat (b, concat (" ", concat (gottenValue, ", "))))
		}
		/* call getValueCont (root, "CALN") 
		   if (gotValue) { 
		   set (b, concat (b, concat ("Cote ", concat (gottenValue, ", "))))
		   }
		 */
		call getValueCont (root, "PAGE") 
		if (gotValue) { 
			set (word, "page ")
			if (or (index (gottenValue, "-", 1),
						or (index (gottenValue, ",", 1),
							index (gottenValue, "et ", 1)))) {
				set (word, "pages ")
			}
			set (b, concat (b, concat (word, concat (gottenValue, ", "))))
		}
		call getValueCont (root, "FILM") 
		if (gotValue) { 
			set(b, concat(b, concat("Microfilm numéro ", concat(gottenValue, ", "))))
		}
		call getValueCont (root, "FICH") 
		if (gotValue) {
			set(b, concat(b, concat("Microfiche numéro ", concat(gottenValue, ", "))))
		}
		/* TODO : C'est du niveau d'Hérédis */
		/*
		call getValueCont (root, "REPO") 
		if (gotValue) { 
			set (b, concat (b, concat ("à ", concat (gottenValue, ", "))))
		}
		if (index (b, ", ", 1)) {
			set (b, concat (substring (b, 1, sub (strlen (b), 2)), "."))
		}
		*/

		call getValueCont (root, "NOTE") 
		if (gotValue) { set (b, concat (b, concat (" ", gottenValue))) }

		call getValueCont (root, "TEXT") 
		if (gotValue) { set (b, concat (b, concat (" ", gottenValue))) }

		call getValueCont (root, "SOUR") 
		if (gotValue) { 
			set (bb, "?")
			if (gottenValue) {
				set (a1, index (gottenValue, "@", 1))
				set (a2, index (gottenValue, "@", 2))
				if (and (eq (a1, 1), eq (a2, strlen (gottenValue)))) { 
					set (bb, 
							substring (gottenValue, 2, sub (strlen (gottenValue), 1)))
				}
			}
			set (b, concat (b, concat ("~\\cite{", concat (bb, "}"))))
		}

		if (figureFlag) {
			set (b, concat (b, concat (" Voir figure page~", concat (pref, "."))))
		}
		enqueue (bibList, concat (b, "\n"))
	}
}

proc getText (root, paragraph) 
{
	set (pronounOkay, 1)
	if (root) {
		if(eq(1,notes_text_mode)){   /* only 1 TEXT records */
			fornodes (root, node) {
				if (not (strcmp ("TEXT", tag (node)))) {
					set (pronounOkay, 0)
					if (paragraph) { "\n\n" set (paragraph, 0) }
					call values (node)
					"\n\n"
				}
			}
		}
		else {
			if(eq(2,notes_text_mode)) { /* all 1 NOTE records */
				fornotes (root, note) {
					if (paragraph) { "\n\n" set (paragraph, 0) }
					note
					"\n\n"
					set (pronounOkay, 0)
				}
			}
			else{   /* only !-tagged 1 NOTE records (1st char must be !) */
				fornotes (root, note) {
					set (i, index(note,"!",1))
					if (eq(1,i)){
						set (pronounOkay, 0)
						if (paragraph) { "\n\n" set (paragraph, 0) }
						substring(note, 2, strlen(note))
						"\n\n"
					}
				}
			}
		}
	}
	/* if we printed any notes, then reset things so we don't use
	   "there" in place names right after the notes. */
	if (not (pronounOkay)){
		insert (eventPlaceTable, "@there@", "")
	}
}

proc values (root)
{
	if (root) {
		if (strlen (value (root))) { "\n" value (root) }
		fornodes (root, node) {
			if (not (strcmp ("CONT", tag (node)))) {
				if (strlen (value (node))) {
					"\\\\\n" value(node)
				}
			} elsif (not (strcmp ("CONC", tag (node)))) {
				if (strlen (value (node))) {
					value(node)
				}
			}
		}
		if (root) { enqueue (sourceList, root) }
		call sourceIt (sourceList)
	}
}
/********************************************************************/
/* below here are routines for printing descendent charts */
/* 
 * These are adapted from desc-tex
 * By Eric Majani (eric@elroy.jpl.nasa.gov)
*/
proc desc_chart_main3(indi)
{
      "\\tree\n"
      call desc_chart_out(indi,3,1)
      "\\endtree\n"

}
proc tree_dates(indiv)
{
	set(date1, "")
	set(date2, "")
	set(trdate, " ")

	if(e, birth(indiv)) {set(date1, year(e))}
	if(eq(date1, "")) {
		if(e, baptism(indiv)) {set(date1, year(e))}
	}
	if(e, death(indiv)) {set(date2, year(e))}
	if(eq(date2, "")) {
		if(e, burial(indiv)) {set(date2, year(e))}
	}
	if(ne(date1, "")) {set(trdate, concat(trdate,date1))}
	if(ne(date2, "")) {
		set(trdate, concat(trdate, "-", date2))
	}
}

proc descch_indi(indi)
{
	"{\\bf " call desc_chart_name(indi) "}"
	call tree_dates(indi)
	trdate
	nl()
	families(indi,fam,sp,num)
	{
		if(e,marriage(fam)) {
			"   m. " short(e)  nl()
		}
	}
}
proc desc_chart_name(i)
{
	set (whole,givens(i))
	set (space,index(whole," ",1))
	if (gt(space,0)){
		substring(whole,1,space)
	}
	else {whole " "}
	if (eq(strcmp(surname(i), "____"), 0)) {
		" \\noname" 
	} else {
		surname(i) 
	} 
}
proc descch_indinomar(indi)
{
	"{\\bf " call desc_chart_name(indi) "}"
	call tree_dates(indi)
	trdate
	nl()
}

proc descch_prcouple(indi,fam,num)
{
	if(eq(num,1))
	{
		"{\\bf " call desc_chart_name(indi) "}" 
		call tree_dates(indi)
		trdate
	}
	nl()

	/* I can't remember why I put this IF in here. I guess I'll take it out
	   and see what breaks! */
	/*      if(eq(num,nfamilies(indi)))*/ 
	/*      {*/
	if (e,marriage(fam)) { " m. " year(e) " " }
	else {"m.\\ \\ \\ \\ \\ \\ " } /* space over without date */
	/*      }*/
}
proc descch_printfam(indi,fam,sp)
{
      "\\spouse{ " call desc_chart_name(sp) "}" nl()
}

proc desc_chart_out(indi,depth,level)
{
	if(or(eq(0,nfamilies(indi)),eq(depth,level)))
	{
		call descch_indinomar(indi)
	}
	if(lt(level,depth)){
		families(indi,fam,sp,num)
		{         
			call descch_prcouple(indi,fam,num)
			call descch_printfam(indi,fam,sp)
			set(level,add(level,1))
			set(num2,0)
			if(le(level,depth))
			{
				children(fam,child,num2)
				{
					"\\subtree " nl()
					call desc_chart_out(child,depth,level)
					"\\endsubtree " nl()
				}
			}
			set(num2,nchildren(fam))
			set(level,sub(level,1))
			set(temp1,ne(num,nfamilies(indi)))
			set(temp2,gt(num2,0))
			if(and(temp1,temp2))
				/*            if(ne(num,nfamilies(indi)))*/
			{
				if (eq(level,1)){
					"\\endtree " nl()
					"\\tree " nl()
				}
				else {
					"\\endsubtree " nl()
					"\\subtree "  nl()
				}

			}
		}
	}
}

proc excursion(indi)
{
	list (anclist)
	indiset(ancset)

	"\n\\section{Les ancêtres de "  name(indi) "}" "\n"
	"\\label{" key(indi) "-excur-ref}" "\n"

	/* get us to the patriarch of the line.*/
	set(thisguy,indi)
	addtoset(ancset,thisguy,0)
	while (father(thisguy)){
		set(thisguy,father(thisguy))
		push(anclist,thisguy)
		addtoset(ancset,thisguy,0)
	}
	"La lignée " surname(indi) " a été tracée jusqu'à "
	call texname(thisguy, inode(thisguy), 0) "."

	while(indi,pop(anclist)){
		print ("Excursion: ") print(name(indi)) print("\n")
		call longvitals(indi,1,2)
		families(indi, fam, spouse, nfam) {
			"\n\n"
			if (eq(0, nchildren(fam))) {
				call texname(indi, inode(indi), 0) "\\ et "
				if (spouse) {
					call texname(spouse, inode(spouse), 0)
				} else {
					"\\noname"
				}
				call havehadchildren(indi, spouse)
			} elsif (and(spouse, lookup(stab, key(spouse)))) {
				"Les enfants de " call texname(indi, inode(indi), 0) "\\ et "
				call texname(spouse, inode(spouse), 0) "\\ sont donnés sous "
				call texname(spouse, inode(spouse), 0)
				"~(" d(lookup(stab, key(spouse))) ").\n\n"
			} else {
				"Les enfants de " call texname(indi, inode(indi), 0) "\\ et "
				if (spouse) {
					call texname(spouse, inode(spouse), 0)
				} else {
					"\\noname"
				}
				":\n\\begin{childrenlist}\n"
				children(fam, child, nchl) {
					"\n\\item "
					set(personIsAnc,0)
					forindiset(ancset,them,val,num){
						if (eq (them,child)){
							set(personIsAnc,1)
						}
					}
					if (personIsAnc){
						"**" call shortvitals(child)
					}
					else{
						call longvitals(child, 0,2)
					}
					addtoset(idex, child, 0)
				}
				"\\end{childrenlist}\n"
			}
		}
	}
	"\n\n\n"
}

/*
 vim:fdm=marker
 */
