/*
@progname	conjpar
@version 	1.0 of 24-Sep-2008
@author 	Patrick Texier (p.texier@genindre.org)
@category
@output 	Text delimited
@description
			liste des conjoints descendant d'une personne
			et qui n'ont pas leurs parents dans la base
*/

char_encoding("UTF-8")
include("ptfunct.li")

global(base)

proc main()
{
	/* initialisation des compteurs et séparateur */
	set(sep, ";")
	set(cpt1, 0)
	set(cpt2, 0)
	set(cpt3, 0)
	/* sélections */ 
	getindi(base, "Descendance de :")
	list(menutype)
	setel(menutype, 1, "Descendance complète")
	setel(menutype, 2, "Descendance masculine")
	set(typed, menuchoose(menutype, "Sélectionnez le type de descendance"))
	getint(annee, "Année maximum")
	"nom;prénoms;clé;naiss;mar;décès\n"
	/* constitution de la liste des descendants */
	if(eq(typed, 1)) {
		set(libd, "(Descendance complète)")
		indiset(setbase)
		addtoset(setbase, base, 0)
		indiset(setdesc)
		set(setdesc, descendentset(setbase))
	}
	else {
		set(libd, "(Descendance masculine)")
		indiset(setdesc)
		call maledescendentset(setdesc, base)
	}
	set(cpt1, length(setdesc))
	/* lecture de la liste des descendants */
	forindiset(setdesc, oneindi, bidon, cpt) {
		/* lecture des épouses */
		spouses(oneindi, onespouse, fami, cpts) {
			if(not(parents(onespouse))) {
				incr(cpt2)
				/* test année de mariage */
				if(year(marriage(fami))) {
					set(mardate, strtoint(year(marriage(fami))))
				}
				else {
					set(mardate, 0)
					/* pour ne pas prendre en compte les mariages
					   sans date */
					/* set(mardate, 9999) */
				}
				if(le(mardate, annee)) {
					incr(cpt3)
					/* écriture de la ligne dans le fichier */
					surname(onespouse) sep
					givens(onespouse) sep
					key(onespouse) sep
					date(birth(onespouse)) sep
					date(marriage(fami)) sep
					date(death(onespouse))
					"\n"
				}
			}
		}
	}
	/* Affichage des statistiques */
	print(d(cpt1), " descendants ", libd, " :\n")
	print(d(cpt2), " couples de beaux-parents manquants : ")
	set(bidon, sub(cpt2, cpt3))
	print(d(cpt3), " écrits, ", d(bidon), " trop récents")
}
