/*
 * @progname       coverage-pt
 * @version        2.0 du 20-09-2007
 * @author         Wetmore, Woodbridge, Eggert
 * @category       
 * @output         Text
 * @description    
 *

   Displays "ancestor coverage," that is, what percentage of
   ancestors have been discovered for each generation back in time.

   First version by T. Wetmore, 21 February 1994
   2nd   version by S. Woodbridge, 6 March 1994
   3rd   version by J. Eggert, 7 March 1994

   coverage-pt 1.0 : Patrick Texier calcul de l'implexe

*/
char_encoding("UTF-8") 

proc main ()
{
	getindi(indi0, "Sélectionnez le de-cujus.")
	print("Calculs en cours... \n")
	list(ilist)
	list(glist)
	list(garray)
	table(dtable)
	list(darray)
	enqueue(ilist, indi0)
	enqueue(glist, 1)
	while(indiv, dequeue(ilist)) {
		set(gen, dequeue(glist))
		set(i, getel(garray, gen))
		set(i, add(i, 1))
		setel(garray, gen, i)
		if (not(lookup(dtable, key(indiv)))) {
			insert(dtable, key(indiv), gen)
			set(i, getel(darray, gen))
			set(i, add(i, 1))
			setel(darray, gen, i)
		}
		/* Ici, il faudrait tester que se ne sont pas
		des ancêtres virtuels entrés parce que l'on
		connait un collatéral du plus ancien
		Soit pour moi : N /patronyme/ & Ne //
		*/
		if (par,father(indiv)) {
			enqueue(ilist, par)
			enqueue(glist, add(1, gen))
		}
		if (par,mother(indiv)) {
			enqueue(ilist, par)
			enqueue(glist, add(1, gen))
		}
	}
	set(implexe, 0.1)
	set(i, 1)
	set(tot, 1)
	set(num, getel(garray, i))
	set(dnum, getel(darray, i))
	set(numsum, num)
	set(dnumsum, dnum)
	"Nombre d'ancêtres par générations pour " name(indi0) "\n\n"
	col(1) "Gen" col(6) "Total" col(16) "Connus"
	col(26) "(Diff)" col(38) "% connus" col(50) "% implexe" "\n\n"
	while (num) {
		col(1) d(i)
		col(6) if (lt(i,31)) { d(tot) }
		col(16) d(num)
		if (ne(num, dnum)) { col(26) "(" d(dnum) ")" }
		if (lt(i,31)) { col(38)
			set(u, mul(num, 100))
			set(q, div(u, tot))
			set(m, mod(u, tot))
			set(m, mul(m, 100))
			set(m, div(m, tot))
			d(q) "." if (lt(m, 10)) {"0"} d(m) " %"
			set(tot, mul(tot, 2))
		}
		col(50)
		set(u, mul(sub(num, dnum), 100))
		set(q, div(u, num))
		set(m, mod(u, num))
		set(m, mul(m, 100))
		set(m, div(m, num))
		d(q) "." if (lt(m, 10)) {"0"} d(m) " %"

		set(i, add(i, 1))
		set(num, getel(garray, i))
		set(dnum, getel(darray, i))
		set(numsum, add(numsum, num))
		set(dnumsum, add(dnumsum, dnum))
		print(d(i), "  ", d(num), "\n")
	}
	"\n\n"
	col(1) "toutes" col(16) d(numsum)
	if (ne(numsum, dnumsum)) { col(26) "(" d(dnumsum) ")" }
	"\n"
}
