/* leclair.ll {{{1
         
@progname	leclair
@version 	3.0 of 2008-07-10
@author 	Patrick Texier (p.texier@genindre.org)
@category
@output 	Text delimited
@description 

Liste éclair avec gestion de tables de correspondances pour
les codes GeneaNet dans leclair.li à adapter à ses besoins.
Les régions/sous régions sont gérées automatiquement à partir des
codes Insee en France et Ins en Belgique. Cette édition nécessite
d'avoir des lieux uniformément découpés.

   Sortie d'une liste éclair.

   Patrick Texier 

   29 NOV 2002		1.0
   	Premier jet

   07 DEC 2002          2.0
   	Gestion de plusieurs formats de listes (CGW, Geneanet).

	Les tables de correspondance sont dans le fichier 
	leclair.li

	On peut supprimer des sélections et mettre des valeurs par
	défaut.

	Sélections :

	A/ - Toute la base
	- Ascendance d'une personne.
	- Descendance d'une personne.

	B/ Utilisation de la table de conversion des noms (O/N)
	Permet de remplacer par exemple DURAND par DURAND, DURANT

	C/ Type de liste éclair :

	- Lifelines.
	- Geneanet (pour consistituer son index).
	- Geneanet "avancé", c'est le format Geneanet avec en plus le nombre
	  d'entrées par actes. NE PAS ENVOYER AU SITE.
	- CousinsGenWeb : nom;commune;département (uniquement la France).
	
	D/ Lignes sans lieux o/n

	E/ Restructuration des lieux o/n. Permet de changer l'ordre du lieu
	ou d'en supprimer certaines parties. C'est la clé utilisée pour la constitution
	de la liste éclair.

	Ensuite, le programme demande l'ordre des lieux à prendre : les lieux sont
	numérotés de 1 à N.

	Par exemple, j'utilise
	1 : Commune
	2 : Code INSEE/INS, Région étrangère.
	3 : Lieu-dit, paroisse.
	4 : Pays

	Pour supprimer le lieu-dit, je saisis 124.

	Attention, c'est la structure du lieu pour les sélections suivantes. Donc :
	1 : Commune
	2 : Code INSEE/INS, Région étrangère.
	3 : Pays
	
	F/ Ordre des lieux en sortie.
	Cette sélection permet de supprimer un découpage de lieu dans la liste éclair
	générée. Par exemple, je supprime le pays lors d'une liste Geneanet puisque le pays
	est dans un champ séparé du lieu.

	G/ Conversion code pays o-n
	Cette option est obligatoire pour sortir une liste geneanet si les pays dans la
	base ne sont pas au format GeneaNet (FRA, BEL, DEU...).
	C'est aussi nécessaire pour CousinsGW si le pays France n'est pas FRA.
	La table de conversion est dans le fichier leclair.ll : tabconvpays.

	H/ Position du code pays 1-n
	Indispensable pour Geneanet/CousinsGW ou si on convertit les codes pays.

	J/ Position du code-lieu numérique 1-n.
	Indispensable pour Geneanet/CousinsGW. Cela permet de retrouver où se situe le
	département français ou la province belge et d'attribuer les codes régions Geneanet 
	automatiquement. On peut utiliser les codes postaux ou INSEE pour la France, mais 
	uniquement les codes INS pour la Belgique. Les DOM/TOM sont gérés (97/98).

	K/ Position du nom région/etat texte.
	Cela permet de gérer une table de correspondance par pays/région pour attribuer
	les codes région Geneanet.

	L/ Position du nom de la commune (uniquement CousinsGenWeb).
	C'est le lieu qui sera exporté

	M/ Recherche contrats de mariage O/N
	Permet deprendre en compte les contrats de mariage (MARC) quand on n'a pas
	de mariage (MARR).

	15 DEC 2002 	2.02
	Prise en compte de la Corse 2A et 2B pour GeneaNet (F20)

	12 Avril 2004	2.10
	Correction des lignes sans lieux qui récupéraient des virgules
	en cas de redécoupage.

	25 mai 2005		2.20
	Correction de la sélection pour supprimer les lignes sans lieux.
	Il y avait un test avec eq au lieu de eqstr.

	10 juillet 2007 3.0
	- Possibilité de ne pas prendre en compte les personnes qui ont
	un 1 RESN remove.
	- Si on prend toute la base, on ne charge plus d'indiset : le temps
	de traitement est divisé par 3 ou 4.
}}}1 */

/*option("explicitvars") */
include("leclair.li")
include("ptfunct.li")
include("ptinit.li")
char_encoding("UTF-8")

/* Déclarations {{{1 */
global(idx)
global(indiv)
global(n)
global(i)
global(ws)
global(nbr)
global(person)
global(ind)
global(snum)
global(nom)
global(lieun)
global(lieud)
global(evtnaiss)
global(evtmarr)
global(evtdeces)
global(fami)
global(ind2)
global(fnum)
global(lstcles)
global(lstnom)
global(lstcomm)
global(lstlieu)
global(lstnbindi)
global(lstnbnaiss)
global(lstnbmarr)
global(lstnbdeces)
global(lstdatemin)
global(lstdatemax)
global(lstpartlieu)
global(lstsepnomlieu)

global(maxlst)
global(indlst)
global(tabcles)
global(tabnoms)
global(tabindilieu)
global(tabconvpays)
global(tabconvregion)
global(tabsregion)
global(tabconvnom)
global(tabcommune)
global(positionpays)
global(positioncodelieu)
global(positionregion)
global(positioncommune)
global(codelieu)

global(cleindilieu)
global(cle)
global(sep)
global(lindi)
global(sortie)
global(structlieu)
global(structlieuaff)
global(lieu)
global(lieuaff)
global(pays)
global(region)
global(commune)
global(sousregion)
global(max)
global(retour)
global(typeliste)
global(typegeneanet)
global(choixpers)
global(indisel)
global(travset)
global(travset2)

global(flmarc)
global(fldeclieu)
global(flsanslieu)
global(flconvnoms)
global(flconvpays)
global(flmasquer)

global(flcomm)	/* Commentaires O/N */
global(libcomm)	/* Libellé commentaire */
global(indicomm) /* Personne à mettre l'ascendance en commentaires */
global(setcomm) /* Ensemble des ascendants */

global(true)
global(false)

global(llexec) /* 1 -> pas de sélection */
/* fin déclarations  */

proc main() /* {{{1 */
{
	set(llexec, 0)
	call init()
	if(llexec) {
		call selection_auto()
	}
	else {
		call selection()
	}
	/* Declaration des listes, tables et indiset {{{2 */
	list(lstcles)
	list(lstcomm)
	list(lstnbindi)
	list(lstnbnaiss)
	list(lstnbmarr)
	list(lstnbdeces)
	list(lstdatemin)
	list(lstdatemax)
	list(lstpartlieu)
	list(lstsepnomlieu)

	table(tabcles)
	
	indiset(idx)
	indiset(travset)
	indiset(travset2)
	indiset(setcomm)
	/* Ecriture entete pour ouvrir le fichier avant traitement {{{2 */
	if(eq(typeliste, 1)) {
		"Nom;Lieu;DateMin;DateMax;Nbre;°;x;+" nl()
	}
	else {
		if(eq(typeliste, 2)) {
			"Nom;Commentaire;DateMin;DateMax;Nbre;Lieu;SousRégion;Région;Pays;Type\n"
		}
		else {
			if (eq(typeliste, 3)) {
				"Nom;Commentaire;DateMin;DateMax;Nbre;°;x;+;Lieu;SousRégion;Région;Pays;Type\n"
			}
			else {
				"Nom;Commune;Département\n"
			}
		}
	}
	/* Chargement {{{2 */
	/* Si commentaires Geneanet, on charge l'ensemble des ascendants */
	if(flcomm) {
		print("Chargement de la liste des ascendants\n")
		addtoset(travset2, indicomm, n)
		set(setcomm, ancestorset(travset2))
	}
	if(eq(choixpers, 1)) {
		print("Traitement de toute la base\n")
	}
	else {
		print("Chargement de la liste\n")
		addtoset(travset, indisel, n)
		if(eq(choixpers, 2)) {
			set(idx, ancestorset(travset))
		}
		else {
			set(idx, descendentset(travset))
		}

		print ("Tri en cours...\n") 
		namesort(idx)
	}
	print ("Traitement en cours...\n") /* {{{2 */
	call traitement()
	/* sort(lstcles) */
	print ("Nombre de lignes :") print (d(maxlst)) print (nl())
	print ("Ecriture de la liste...\n")
	call ecriture()
}

proc init() /* {{{1 */
{
	/* Chargement des tables de conversion de leclair.li */
	set(false, 0)
	set(true, 1)
	call chargecodes()
	set(evtnaiss, 1)
	set(evtmarr, 2)
	set(evtdeces, 3)
	set(sep, ";")
	set(typegeneanet, "L") /* Arbre en ligne W, sinon mettre L */
	set(libcomm, "Ancêtres personnels")
	set(maxlst, 0)
}
/* }}}1 */
proc selection_auto() /* {{{1 */
{
	set(choixpers, 1)
	set(flmasquer, 1)
	set(flconvpays, 1)
	set(typeliste, 2)
	set(flsanslieu, 0)
	set(fldeclieu, 1)
	set(structlieu, "1245")
	set(structlieuaff, "12")
	set(flconvpays, 1)
	set(positionpays, 4)
	set(positioncodelieu, 2)
	set(positionregion, 3)
	set(positioncommune, 1)
	set(flcomm, 1)
	set(indicomm, indi("I1"))
	set(flmarc, 1)
}
/* }}}1 */
proc selection() /* {{{1 */
{
	/* Choix personnes à prendre en compte {{{2 */
	if(1) {
		list(options)
		setel(options, 1, "Toute la base")
		setel(options, 2, "Ascendants d'une personne")
		setel(options, 3, "Descendants d'une personne")
		set(choixpers, -1)
		while(lt(choixpers, 0)) {
			set(choixpers, menuchoose(options, "Choix prise en compte : "))
			if(eq(choixpers, 0)) {break()}
			if(ge(choixpers, 2)) {
				getindi(indisel, "Selectionnez une personne : ")
			}
		}
	}
	else {
		set(choixpers, 1)
	}
	/* Choix masquage {{{2 */
	if(1) {
		getint(flmasquer,"Masquer les 1 REFN remove 0-Non 1-Oui")
	}
	else {
		set(flmasquer, 0)
	}
	/* Restructuration des noms {{{2 */
	if(1) {
		getint(flconvnoms, "Table de conversion des noms 0-Non 1-Oui")
	}
	else {
		set(flconvnoms, 0)
	}

	/* Choix du type de liste {{{2 */
	if(1) {
		list(options)
		setel(options, 1, "LifeLines")
		setel(options, 2, "Geneanet")
		setel(options, 3, "'Geneanet' détail actes")
		setel(options, 4, "CousinsGenWeb")
		set(typeliste, -1)
		while(lt(typeliste,0)) {
			set(typeliste, menuchoose(options, "Type de liste éclair :"))
			if(eq(typeliste, 0)) {break()}
		}
	}
	else {
		set(typeliste, 1)
	}
	/* Lignes sans lieux (Non pour CGW) {{{2 */
	if(1) {
		if(ne(typeliste, 4)) {
			getint(flsanslieu, "Lignes sans lieux 0-Non 1-Oui")
		}
		else {
			set(flsanslieu, 0)
		}
	}
	else {
		set(flsanslieu, 1)
	}
	
	/* Restructuration des lieux {{{2 */
	set(positionpays, 0)
	if(1) {
		getint(fldeclieu, "Restructuration des lieux 0-Non 1-Oui")
	}
	else {
		set(fldeclieu, 0)
	}
	if(fldeclieu) {
		getstr(structlieu, "Ordre des lieux à prendre (ex: 4213)")
		getstr(structlieuaff, "Ordre des lieux en sortie (ex: 4213)")
		getint(flconvpays, "Conversion codes pays 0-Non 1-Oui")
		/*
		if(flconvpays) {
			getint(positionpays, "Position du code pays (1-n)")
		}
		*/
	}
	/* Code pays obligatoire pour Geneanet / CGW */
/*	if(and(ne(positionpays, 0), ge(typeliste, 1))) { */
		getint(positionpays, "Position du code pays (1-n)")
/*	} */
	/* Code lieu numérique {{{2 */
	if(1) {
		getint(positioncodelieu, "Position du code lieu numérique (FRA, BEL)")
	}
	else {
		set(positioncodelieu, 2)
	}
	/* Position état (Sauf pour CGW) {{{2 */
	if(1) {
		if(ne(typeliste, 4)) {
			getint(positionregion, "Position du nom région/état texte")
		}
		else {
			set(positionregion, 0)
		}
	}
	else {	
		set(positionregion, 0)
	}
	/* Position commune (pour CGW) {{{2*/
	set(positioncommune, 0)
	if(1) {
		getint(positioncommune, "Position du nom de la ville")
	}
	else {	
		set(positioncommune, 1)
	}
	/* Pour généanet, commentaire sur la ligne d'ascendance {{{2 */
	if(1) {
		if(or(eq(typeliste, 2), eq(typeliste, 3))) {
			getint(flcomm, "Ascendance en commentaire 0-Non 1-Oui")
			if(flcomm) {
				getindi(indicomm, "Sélectionnez une personne")
			}
		}
		else {
			set(flcomm, 0)
		}
	}
	/* Recherche des contrats de mariage {{{2 */
	if(1) {
		getint(flmarc, "Recherche contrats de mariage 0-Non 1-Oui")
	}
	else {
		set(flmarc, 0)
	}
}
/* }}}1 */
proc traitement()  /* {{{1 */
{
	if(eq(choixpers, 1)) {
		forindi(person, ind) {
			if(flmasquer) {
				if(not(resn(person))) {
					call traitement_indi(person)
				}
			}
			else {
				call traitement_indi(person)
			}
		}
	}
	else {
		forindiset(idx, person, ind, snum) {
			call traitement_indi(person)
		}
	}
}

proc traitement_indi(person) { /* {{{1 */
	/* Réinitialisation de la table individu/lieu */
	table(tabindilieu)

	set(nom, surname(person))
	if(flconvnoms) {
		set(ws, lookup(tabconvnom, nom))
		if(ws) {set(nom, ws)}
	}
	/* Recherche naissance/baptême {{{2 */
	set(lieun, place(birth(person)))
	if(eq(lieun, 0)) {
		set(lieun, place(baptism(person)))
	}
	set(daten, year(birth(person)))
	if(eq(daten, 0)) {
		set(daten, year(baptism(person)))
	}
	if(or(not(eq(lieun, 0)), not(eq(daten, 0)))) {
		call ligne(person, nom, lieun, evtnaiss, daten)
	} /* }}}2
	/* Recherche décès/inhumation {{{2 */
	set(lieud, place(death(person)))
	if(eq(lieud, 0)) {
		set(lieud, place(burial(person)))
	}
	set(dated, year(death(person)))
	if(eq(dated, 0)) {
		set(dated, year(burial(person)))
	}
	if(or(not(eq(lieud, 0)), not(eq(dated, 0)))) {
		call ligne(person, nom, lieud, evtdeces, dated)
	}
	/* Recherche mariages {{{2 */
	families(person, fami, ind2, fnum) {
		set(lieum, place(marriage(fami)))
		set(datem, year(marriage(fami)))
		if(or(not(eq(lieum, 0)), not(eq(datem, 0)))) {
			call ligne(person, nom, lieum, evtmarr, datem)
		}
		else {
			if(flmarc) {
				fornodes(fnode(fami), mynode) {
					if(eqstr(tag(mynode), "MARC")) {
						fornodes(mynode, nodemarc) {
							if(eqstr(tag(nodemarc), "DATE")) {
								set(datem, year(value(nodemarc)))
							}
							if(eqstr(tag(nodemarc), "PLAC")) {
								set(lieum, value(nodemarc))
							}
						}
					}
				}
				if(or(not(eq(lieum, 0)), not(eq(datem, 0)))) {
					call ligne(person, nom, lieum, evtmarr, datem)
				}
			}
		}
	}
}

func redecouplieu(chaine, structure, compresse) /* {{{1 */
{
	if(eq(chaine, "")) {
		return("")
	}
	extracttokens(chaine, lstpartlieu, nbdecoup, ",")

	set(retour, "")
	set(i, 1)
	set(max, strlen(structure))

	while(le(i, max)) {
		set(ws, getel(lstpartlieu, strtoint(substring(structure, i, i))))
		if(and(flconvpays, eq(positionpays, i))) {
			set(ws2, lookup(tabconvpays, ws))
			if(ws2) {set(ws, ws2)}
		}
		if(compresse) {
			if(and(ne(i, 1), nestr(ws, ""))) {set(retour, concat(retour, ", "))}
		}
		else {
			if(ne(i, 1)) {set(retour, concat(retour, ", "))}
		}
		set(retour, concat(retour, ws))
		incr(i)
	}
	return(retour)
}

proc ligne (person, nom, lieu, evt, datev) /* {{{1 */
{
	/* Test lieu vide et sélection */
	if(and(eq(flsanslieu, 0), eqstr(lieu, ""))) {
		return()
	}
	/* Redécoupage du lieu */
	if(fldeclieu) { set(lieu, redecouplieu(lieu, structlieu, false)) }
	
	set(cle, concat(nom, sep, lieu))
	if(not(lookup(tabcles, cle))) {
		incr(maxlst)

		insert(tabcles, cle, maxlst)
		setel(lstcles, maxlst, cle)
		setel(lstcomm, maxlst, "")
		setel(lstnbindi, maxlst, 0)
		setel(lstnbnaiss, maxlst, 0)
		setel(lstnbmarr, maxlst, 0)
		setel(lstnbdeces, maxlst, 0)
		setel(lstdatemin, maxlst, 9999)
		setel(lstdatemax, maxlst, 0)
	}

	set(indlst, lookup(tabcles, cle))

	/* Si nouveau, une personne de plus */
	set(cleindilieu, concat(key(person), sep, lieu))
	if(not(lookup(tabindilieu, cleindilieu))) {
		set(trav, getel(lstnbindi, indlst))
		incr(trav)
		setel(lstnbindi, indlst, trav)
		insert(tabindilieu, cleindilieu, 1)
	}
	/* Traitement des évènements */
	if(eq(evt, evtnaiss)) {
		set(trav, getel(lstnbnaiss, indlst))
		incr(trav)
		setel(lstnbnaiss, indlst, trav)
	}
	else {
		if(eq(evt, evtmarr)) {
			set(trav, getel(lstnbmarr, indlst))
			incr(trav)
			setel(lstnbmarr, indlst, trav)
		}
		else {
			set(trav, getel(lstnbdeces, indlst))
			incr(trav)
			setel(lstnbdeces, indlst, trav)
		}
	}
	/* Traitement des dates */
	if(datev) {
		/* Date minimum */
		set(trav, getel(lstdatemin, indlst))
		if(lt(strtoint(datev), trav)) {
			setel(lstdatemin, indlst, strtoint(datev))
		}
		/* Date maximum */
		set(trav, getel(lstdatemax, indlst))
		if(gt(strtoint(datev), trav)) {
			setel(lstdatemax, indlst, strtoint(datev))
		}
	}
	/* Ascendants en commentaire Geneanet */
	if(flcomm) {
		if(inset(setcomm, person)) {
			setel(lstcomm, indlst, libcomm)
		}
	}
}
proc ecriture() /* {{{1 */
{
	if(eq(typeliste, 4)) {
		call ecriture_cgw()
	}
	else {
		if(or(eq(typeliste, 2), eq(typeliste, 3))) {
			call ecriture_geneanet()
		}
		else {
			call ecriture_lifelines()
		}
	}
}

proc ecriture_geneanet() /* {{{1 */
{
	forlist(lstcles, cle, indlst) {
		extracttokens(cle, lstsepnomlieu, nbdecoup, sep)
		/* Nom */
		set(sortie, getel(lstsepnomlieu, 1))
		sortie sep
		/* Commentaire */
		if(or(eq(typeliste, 2), eq(typeliste, 3))) {
			set(sortie, getel(lstcomm, indlst))
			sortie sep
		}
		/* Date min */
		set(sortie, getel(lstdatemin, indlst))
		if(ne(sortie, 9999)) {d(sortie)}
		sep
		/* Date max */
		set(sortie, getel(lstdatemax, indlst))
		if(ne(sortie, 0)) {d(sortie)}
		sep
		/* Compteur de personnes */
		set(sortie, getel(lstnbindi, indlst))
		d(sortie) sep
		/* Format "généanet" avancé avec détail actes */
		if(eq(typeliste, 3)) {
			set(sortie, getel(lstnbnaiss, indlst))
			d(sortie) sep
			set(sortie, getel(lstnbmarr, indlst))
			d(sortie) sep
			set(sortie, getel(lstnbdeces, indlst))
			d(sortie) sep
		}
		/* Lieu */
		set(lieu, getel(lstsepnomlieu, 2))
		if(nestr(structlieuaff, "")) { set(lieuaff, redecouplieu(lieu, structlieuaff, true)) }
		lieuaff sep
		/* Sous-région, région, pays */
		extracttokens(lieu, lstpartlieu, nbdecoup, ",")
		set(pays, "")
		set(region, "")
		set(sousregion, "")
		set(commune, "")
		set(pays, getel(lstpartlieu, positionpays))
		set(codelieu, getel(lstpartlieu, positioncodelieu))
		set(commune, getel(lstpartlieu, positioncommune))
		/* Traitement spécifique pays */
		if(eqstr(pays, "FRA")) {
			/* Dom-Tom */
			if(or(eqstr(substring(codelieu, 1, 2), "97"),
			      eqstr(substring(codelieu, 1, 2), "98"))) {
				set(pays, codedomtom(codelieu))
			}
			else {
				if(or(eqstr(substring(codelieu, 1, 2), "2A"),
			      		eqstr(substring(codelieu, 1, 2), "2B"))) {
						set(sousregion, "F20")
				}
				else {
					set(sousregion, concat("F", substring(codelieu, 1, 2)))
				}
				set(ws, lookup(tabconvregion, concat(pays, ";", sousregion)))
				if(ws) {set(region, ws)}
			}
		}
		else {
			if(eqstr(pays, "BEL")) {
				set(ws, substring(codelieu, 1, 2))
				set(ws, lookup(tabconvregion, concat(pays, ";", ws)))
				if(ws) {set(region, ws)}
			}
			else {
				if (positionregion) {
					set(region, getel(lstpartlieu, positionregion))
					set(ws, lookup(tabconvregion, concat(pays, ";", region)))
					if(ws) {set(region, ws)}
					/* Sous-région */
					set(ws, lookup(tabsregion, concat(pays, ";", region, ";", commune)))
					if(ws) {
						set(sousregion, ws)
					}
					else {
						set(ws, lookup(tabsregion, concat(pays, ";", region, ";*")))
						if(ws) {set(sousregion, ws)}
					}
				}
			}
		}
		sousregion
		sep
		region
		sep
		pays
		/* Type Geneanet */
		if(or(eq(typeliste, 2), eq(typeliste, 3))) {
			sep
			typegeneanet
		}
		nl()
	}
}

func codedomtom(codelieu) /* {{{1 */
{
	if(eqstr(substring(codelieu, 1, 3), "971")) {
		return("GLP") /* Guadeloupe */
	}
	if(eqstr(substring(codelieu, 1, 3), "972")) {
		return("MTQ") /* Martinique */
	}
	if(eqstr(substring(codelieu, 1, 3), "973")) {
		return("GUF") /* Guyane française */
	}
	if(eqstr(substring(codelieu, 1, 3), "974")) {
		return("REU") /* Réunion */
	}
	if(eqstr(substring(codelieu, 1, 3), "975")) {
		return("SPM") /* St Pierre et Miquelon */
	}
	if(eqstr(substring(codelieu, 1, 3), "985")) {
		return("MYT") /* Mayotte */
	}
	if(eqstr(substring(codelieu, 1, 3), "986")) {
		return("WLF") /* Wallis et futuna */
	}
	if(eqstr(substring(codelieu, 1, 3), "987")) {
		return("PYF") /* Polynésie française */
	}
	if(eqstr(substring(codelieu, 1, 3), "988")) {
		return("NCL") /* Nouvelle Calédonie */
	}
}
proc ecriture_lifelines() /* {{{1 */
{
	forlist(lstcles, cle, indlst) {
		/* Nom + Lieu */
		cle sep
		set(sortie, getel(lstdatemin, indlst))
		if(ne(sortie, 9999)) {d(sortie)}
		sep
		set(sortie, getel(lstdatemax, indlst))
		if(ne(sortie, 0)) {d(sortie)}
		sep
		/* Compteur */
		set(sortie, getel(lstnbindi, indlst))
		d(sortie) sep
		set(sortie, getel(lstnbnaiss, indlst))
		d(sortie) sep
		set(sortie, getel(lstnbmarr, indlst))
		d(sortie) sep
		set(sortie, getel(lstnbdeces, indlst))
		d(sortie) nl()
	}
}
proc ecriture_cgw() /* {{{1 */
{
	forlist(lstcles, cle, indlst) {
		extracttokens(cle, lstsepnomlieu, nbdecoup, sep)
		/* Nom */
		set(sortie, getel(lstsepnomlieu, 1))
		/* Lieu */
		set(lieu, getel(lstsepnomlieu, 2))
		/* Sous-région, région, pays */
		extracttokens(lieu, lstpartlieu, nbdecoup, ",")
		set(pays, "")
		set(commune, "")
		set(pays, getel(lstpartlieu, positionpays))
		if(eqstr(pays, "FRA")) {
			set(commune, getel(lstpartlieu, positioncommune))
			set(codelieu, getel(lstpartlieu, positioncodelieu))
			sortie sep
			set(ws, lookup(tabcommune, concat(substring(codelieu, 1, 2), ";", commune)))
			if(ws) { 
				ws
			}
			else {
				commune
			}
			sep substring(codelieu, 1, 2) nl()
		}
	}
}
/* }}}1
 vim:fdm=marker
 */
