/* lieux.ll
         
@progname	lieux
@version 	1.99.02 of 2008-05-13
@author 	Patrick Texier (p.texier@genindre.org)
@category
@output 	Text delimited
@description 

Liste de tous les actes d'un lieu

*/

char_encoding("UTF-8") 
option("explicitvars")

global(true)
global(false)
global(ptutf8)
global(symbdeat)
global(symbburi)
global(sep)
global(options)
global(choixpers)
global(indisel)
global(partlieu)
global(sellieu)
global(idx)
global(travset)
global(indiv)
global(ind)
global(snum)
global(e)
global(n)
global(bidon)
global(listlieu)
global(datedeb)
global(datefin)
global(fami)
global(indi2)
global(cpt)
global(cptlignes)
global(source)
global(node)
global(clesource)
global(nodesource)
global(nodelibsource)
global(choixactes)
global(actesnaiss)
global(actesmar)
global(actesdec)
global(pere)
global(mere)
global(conjoint)

proc init()

{
	set(false, 0)
	set(true, 1)
	set(cptlignes, 0)
	set(sep, ";")
	/* Date AAAAMMJJ pour trier */
	dayformat(21)
	monthformat(21)
	yearformat(1)
	dateformat(3)
	/* Choix sur la possibilité d'utiliser des caractères UTF-8 */
	if(1) {
		getint(ptutf8, "Utilisation de caractères UTF-8 ? 0-Non/1-Oui")
	}
	else {
		set(ptutf8, 1)
	}
	if(ptutf8) {
		set(symbdeat, "†")
		set(symbburi, "(†)")
	}
	else {
		set(symbdeat, "+")
		set(symbburi, "(+)")
	}
	/* Choix personnes à prendre en compte */
	if(1) {
		list(options)
		setel(options, 1, "Toute la base")
		setel(options, 2, "Ascendants d'une personne")
		setel(options, 3, "Descendants d'une personne")
		set(choixpers, -1)
		while(lt(choixpers, 0)) {
			set(choixpers, menuchoose(options, "Choix prise en compte : "))
			if(eq(choixpers, 0)) {break()}
			if(ge(choixpers, 2)) {
				getindi(indisel, "Selectionnez une personne : ")
			}
		}
	}
	else {
		set(choixpers, 1)
	}
	if(1) {
		getint(partlieu, "Partie du lieu : ")
	}
	else {
		set(partlieu, 1)
	}
	getstr(sellieu, "Lieu : ")
	if(1) {
		getint(datedeb, "Date début : ")
	}
	if(1) {
		getint(datefin, "Date fin : ")
	}
	if(eq(datefin, 0)) {set(datefin, 9999)}
	/* Choix des actes à prendre en compte */
	set(actesnaiss, 0)
	set(actesmar, 0)
	set(actesdec, 0)
	if(1) {
		list(options)
		setel(options, 1, "Tous les actes")
		setel(options, 2, "Actes de naissance")
		setel(options, 3, "Actes de mariage")
		setel(options, 4, "Actes de décès")
		set(choixactes, -1)
		while(lt(choixactes, 0)) {
			set(choixactes, menuchoose(options, "Choix actes : "))
		}
	}
	else {
		set(choixactes, 1)
	}
	if(eq(choixactes, 1)) {
		set(actesnaiss, 1)
		set(actesmar, 1)
		set(actesdec, 1)
	}
	elsif(eq(choixactes, 2)) {
		set(actesnaiss, 1)
	}
	elsif(eq(choixactes, 3)) {
		set(actesmar, 1)
	}
	elsif(eq(choixactes, 4)) {
		set(actesdec, 1)
	}
}

proc main()
{
	call init()
	/* Ligne d'entête */
	"Clé"
	sep
	"Prénoms"
	sep
	"Nom"
	sep
	"Acte"
	sep
	"Date"
	sep
	"DateTri"
	sep
	"Lieu"
	sep
	"Prénom père"
	sep
	"Nom père"
	sep
	"Prénom mère"
	sep
	"Nom mère"
	sep
	"Prénom conjoint"
	sep
	"Nom conjoint"
	sep
	"Source"
	sep
	"JJ"
	"\n"
	
	indiset(idx)
	indiset(travset)
	list(listlieu)
	print ("Traitement individus...\n")
	/* Si on prend tout pas besoin de charger
	   un indiset */
	if(eq(choixpers, 1)) {
		print("Toute la base") print(nl())
		forindi(indiv, n) {
			call traitement(indiv)
		}
	}
	else {
		addtoset(travset, indisel, n)
		if(eq(choixpers, 2)) {
			set(idx, ancestorset(travset))
			/* le de-cujus n'est pas pris dans ancestorset */
			addtoset(idx, indisel, n)
		}
		else {
			set(idx, descendentset(travset))
			addtoset(idx, indisel, n)
		}
		forindiset(idx, indiv, ind, snum) {
			call traitement(indiv)
		}
	}
	print ("Nombre de lignes trouvées : ", d(cptlignes), "\n")
}

proc traitement(ind)
{
	/* Naissance ou baptème */
	if(actesnaiss) {
		if(e, birth(ind)) {
			call even(ind, "", e, "°")
		}
		else {
			if(e, baptism(ind)) {
				call even(ind, "", e, "b.")
			}
		}
	}
	/* Mariages */
	if(actesmar) {
		families(ind, fami, indi2, cpt) {
			if (e, marriage(fami)) {
				call even(ind, fami, e, "×")
			}
		}
	}
	/* Décès ou inhumation */
	if(actesdec) {
		if(e, death(ind)) {
			/* Pour ne pas prendre les 1 DEAT Y */
			if(or(place(e), date(e))) {
				call even(ind, "", e, symbdeat)
				return()
			}
		}
		if(e, burial(ind)) {
			call even(ind, "", e, symbburi)
		}
	}
}

proc even(ind, fami, e, lib)
{
	/* Test lieu */
	if(lieu, place(e)) {
		extractplaces(e, listlieu, bidon)
	}
	else {
		return()
	}
	/* Test date */
	if(annee, year(e)) {
		if(or(lt(strtoint(annee), datedeb), gt(strtoint(annee), datefin))) {
			return()
		}
	}
	else {
		return()
	}
	set(testlieu, getel(listlieu, partlieu))
	if(eqstr(testlieu, sellieu)) {
		/* La ligne est bonne, on va rechercher la source et
		l'écrire dans le fichier de sortie */
		call getsource(e)
		incr(cptlignes)
		key(ind) sep
		givens(ind) sep
		surname(ind) sep
		lib sep
		date(e) sep
		stddate(e) sep
		lieu sep
		if(pere, father(ind)) {
			givens(pere) sep
			surname(pere) sep
		}
		else {sep sep}
		if(mere, mother(ind)) {
			givens(mere) sep
			surname(mere) sep
		}
		else {sep sep}
		if(eqstr(lib, "×")) {
			if(eqstr(sex(ind),"M")) {
				set(conjoint, wife(fami))
			}
			else {
				set(conjoint, husband(fami))
			}
			givens(conjoint) sep
			surname(conjoint) sep
		}
		else {sep sep}
		source
		sep
		d(date2jd(date(e)))
		nl()
	}
}
/* Recherche de la première source */
proc getsource(e)
{
	set(source, "")
	set(clesource, "")
	fornodes(e, node) {
		if(eqstr(tag(node), "SOUR")) {
			set(clesource, value(node))
			/* On recherche la source par pointeur
			   si c'est bien une reference, on se
			   positionne sur l'enregistrement source */
			if(reference(clesource)) {
				set(nodesource, dereference(clesource))
				/* On prend la première ligne de la source */
				if(notelibsource, child(nodesource)) {
					set(source, value(notelibsource))
				}
				else {
					set(source, concat("Source vide : ", clesource))
				}
			}
			else {
				set(source, concat("Source inconnue : ", clesource))
			}
			return()
		}
	}
}
