/*
@progname		ps-fan-pt
@version		1.0
@author		Blumer, Deacon, Texier
@category
@output		PostScript
@description

Adaptation de ps-fan en français.

 *
 *   ps-fan-pt , 22 décembre 2001
 *
 *   Adapté de ps-fan1 (nécessite ps-fan-pt.ps)
 *
 *   - Date de baptème si pas de naissance
 *   - Date d'inhumation si pas de décès
 *   - Affichage des dates en format complexe court (traduit avec Lf-pt)
 *   - Affichage de la date de mariage
 *   - Affichage possible des lieux (mais risques de chevauchement)
 *   - Correction des accents PostScript
 *
 *   ps-fan1, Aug 16, 1993
 *
 *   Code (by Tom re-arranged) by Andrew Deacon, deacon@inf.ethz.ch
 *
 *   This report works only with the LifeLines Genealogy program
 *
 *   This report was adapted from a file made by Cliff Manis using the
 *   GEDCHART software written by Tom Blumer.
 *
 *   Output is a PostScript file. The file "ps-fan.ps" is included
 *   when the report is generated. This file consists of the PostScript
 *   commands used by the GEDCHART software written by Tom Blumer.
 *
 */
char_encoding("UTF-8")

global(PS_HDR_FILE)
global(TRUE)
global(FALSE)
global(evt)
global(libevt)
global(flplace)
global(flcp)
global(libplace)

proc main ()
{
		set(TRUE, 1)
		set(FALSE, 0)
        set (nl,nl())
        getindi(indiv)

		/* Choix édition des lieux */

		if(TRUE) {
			getint(flplace, "Edition des lieux ? 0/Non 1/Oui") }
		else {
			set(flplace, 0)
		}
		if(TRUE) {
			if(flplace) {
				getint(flcp, "Code lieu en 2nde position ? 0/Non, 1/Oui")
			}
			else {
				set(flcp, 0)
			}
		}
        set(PS_HDR_FILE, "ps-fan-pt.ps")   /* PostScript Header file name */
        /* copyfile(PS_HDR_FILE) */
        call pedigree(0, 1, 1, indiv, indiv)
        "showpage" nl()                 /* PostScript Tail command */
}

proc pedigree (in, lev, ah, indiv, spous)
{

		dayformat(2)
		monthformat(4)
		dateformat(0)


        "(" fullname(indiv, 1, 1, 50) ")"

		/* BIRT or CHR */

		if (evt, birth(indiv)) { 
			set(libevt, "° ")
			}
		else {
			if(evt, baptism(indiv)) {
				set(libevt,	"b ")
			}
		}
		" ("
		if (evt) { 
			libevt complexdate(evt)
		}
		")"
		if(flplace) {
			if(flcp) {
				" (" substring(place(evt), 1, add(index(place(evt), ",", 1), 3)) ")"
			}
			else {
				" (" substring(place(evt), 1, sub(index(place(evt), ",", 1), 1)) ")"
			}
		}
		/* MARR */
		set(libmarr, "")
		spouses(indiv, indis, fami, n) {
			if(eq(key(indis), key(spous))) {
				if(evt, marriage(fami)) {
					set(libmarr, concat("x ", complexdate(evt)))
				}
			}
		}
		" (" libmarr ")"
		/* DEAT OR BURI */
        " ("
		set(libevt, "")
		if (evt, death(indiv)) {
			if(date(evt)) {
				set(libevt, "+ ")
			}
		}
		if(eqstr(libevt, "")) {
			if(evt, burial(indiv)) {
				set(libevt, "(+) ")
			}
		}
		if(evt) {
			libevt complexdate(evt)
		}
		")"
		if(flplace) {
			if(flcp) {
				" (" substring(place(evt), 1, add(index(place(evt), ",", 1), 3)) ")"
			}
			else {
				" (" substring(place(evt), 1, sub(index(place(evt), ",", 1), 1)) ")"
			}
		}
		else {
			" () ()"
		}
        " " d(in)
        " " d(sub(ah, lev))
        " i"
        nl()

        if (lt(in,4)) {
			set(ifath, father(indiv))
			set(imoth, mother(indiv))
            if (ifath) {
                call pedigree(add(1,in), mul(2,lev), mul(2,ah), ifath, imoth)
            }
            if (imoth) {
                call pedigree(add(1,in), mul(2,lev), add(1,mul(2,ah)), imoth, ifath)
            }
        }
}

