/* titres.ll {{{1
         
* @progname	titres
* @version 	1.0 (16.02.2011)
* @author 	Patrick Texier (p.texier@orsennes.com)
* @category
* @output 	Text
* @description

Export en texte délimité de tous les titres de noblesse
d'une base

/* Export des titres de noblesse 

}}}1 */
/* déclarations {{{1 */
global(sep)
global(indiv)
global(enr)
global(titre)
global(ntit)
global(nomt)
global(info)
global(datnaiss)
global(datdeces)
global(dattitre)
/* }}}1 */
proc main() /* {{{1 */
{
	call init()
	forindi(ind, bidon) {
		set(indiv, ind)
		set(titre, "")
		set(datnaiss, "")
		set(datdeces, "")
		set(info, 0)
		fornodes(inode(indiv), enr) {
			if(eqstr(tag(enr), "TITL")) {
				set(titre, value(enr))
				set(ntit, "")
				set(dattitre, "")
				set(nomt, "")
				if(not(info)) {
					call nd(indiv)
					set(info, 1)
				}
				traverse(enr, enr2, bidon2) {
					if(eqstr(tag(enr2), "_NTIT")) {
						set(ntit, value(enr2))
					}
					elsif(eqstr(tag(enr2), "DATE")) {
						set(dattitre, value(enr2))
					}
					/* mettre "NOTE" pour gedcom GeneWeb */
					elsif(eqstr(tag(enr2), "_NAME")) {
						set(nomt, value(enr2))
					}
				}
				call print_ligne()
			}
		}
	}
} /* }}}1 */
proc init() /* {{{1 */
{
	/* mettre 0 si on veut choisir le fichier */
	if(1) {
		newfile("titres.txt", 0)
	}
	set(sep, ";")
	"Titre" sep
	"Date" sep
	"Clé" sep
	"Prénoms" sep
	"Nom" sep
	"Date naiss" sep
	"Date titre" sep
	"Date décès" sep
	"Jd naiss" sep
	"Jd titre" sep
	"Jd décès"
	"\n"
} /* }}}1 */
proc print_ligne() /* {{{1 */
{
	titre
	if(nestr(ntit, "")) {
		if(eq(strlen(ntit), 1)) {
			set(ntit, concat("0", ntit))
		}
		", " ntit
	}
	sep
	if(nestr(dattitre, "")) {
		d(date2jd(dattitre))
	}
	sep
	key(indiv) sep
	if(nestr(nomt, "")) {
		nomt " (" givens(indiv) ")"
	}
	else {
		givens(indiv)
	}
	sep
	surname(indiv) sep
	sep
	datnaiss sep
	dattitre sep
	datdeces sep
	if(nestr(datnaiss, "")) {
		d(date2jd(datnaiss))
	}
	sep
	if(nestr(dattitre, "")) {
		d(date2jd(dattitre))
	}
	sep
	if(nestr(datdeces, "")) {
		d(date2jd(datdeces))
	}
	"\n"
} /* }}}1 */
proc nd(indiv) /* {{{1 */
{ 
	if(e, date(birth(indiv))) {
		set(datnaiss, e)
	}
	elsif(e, date(baptism(indiv))) {
		set(datnaiss, e)
	}
	if(e, date(death(indiv))) {
		set(datdeces, e)
	}
	elsif(e, date(burial(indiv))) {
		set(datdeces, e)
	}
} /* }}}1 */
/*
 vim: fdm=marker
   */
