/*
 * @progname       vimsrc.ll
 * @version        1.0
 * @author         Patrick Texier
 * @category
 * @output         text
 * @description

 Create a file for Vim source completion
 Cration d'un fichier pour la compltion des sources dans Vim
*/
option("explicitvars")
char_encoding("ISO-8859-1")

global(rec)
global(rec2)
global(cpt)
global(onesrc)
global(auth)
global(titl)
global(caln)
global(keysrc)
global(listsrc)

proc main() {
	newfile("vimsrc.txt", 0)
	list(listsrc)
	forsour(rec, cpt) {
		set(auth, "")
		set(titl, "")
		set(caln, "")
		set(onesrc, "")
		set(keysrc, concat("@", key(rec), "@"))
		fornodes(rec, rec2) {
			if(eqstr(tag(rec2), "AUTH")) {
				set(auth, value(rec2))
			}
			elsif(eqstr(tag(rec2), "TITL")) {
				set(titl, value(rec2))
			}
			elsif(eqstr(tag(rec2), "CALN")) {
				set(caln, value(rec2))
			}
		}
		if(nestr(auth, "")) {
			set(onesrc, auth)
		}
		if(nestr(titl, "")) {
			if(nestr(onesrc, "")) {
				set(onesrc, concat(onesrc, ". ", titl))
			}
			else {
				set(onesrc, titl)
			}
		}
		if(and(eqstr(auth, ""),  nestr(caln, ""))) {
			if(nestr(onesrc, "")) {
				set(onesrc, concat(onesrc, ". ", caln))
			}
			else {
				set(onesrc, caln)
			}
		}
		set(onesrc, concat(onesrc, "|", keysrc))
		push(listsrc, onesrc)
	}
	sort(listsrc)
	forlist(listsrc, onesrc, cpt) {
		onesrc nl()
	}
}
